import _objectSpread from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/objectSpread";
import React from "react";
import { utils } from "zebulon-controls";
import { buildObject, buildFunctionsObject } from "./utils/utils"; // import { datasetFunctions } from "../demo/dataset.functions";

var stringToFunction = function stringToFunction(row, functions) {
  row.functionJS = functions.evalProtectedFunction(row.functionText);
  return true;
};

export var onNext = function onNext(data, message) {
  var indexedColumn = message.meta.table.rowId || message.meta.table.primaryKey;
  data.forEach(function (row) {
    //  a voir deleted row on server side + conflict (zebulon table) => recreation of the row (new_=true) index_=...
    if (message.index) {
      var index = message.index[row[indexedColumn]];

      if (index !== undefined) {
        row.index_ = index;
        var status = message.updatedRows[index];

        if (status) {
          status.row = row;
        } else {
          message.data[index] = row;
        }
      } else {
        message.index[row[message.meta.table.primaryKey]] = message.data.length;
        message.data.push(row);
      }
    } else {
      message.data.push(row);
    }
  });
};
export var onCompleted = function onCompleted(message) {};
export var onError = function onError(e, message) {};

var isLocal = function isLocal(_ref) {
  var row = _ref.row,
      status = _ref.status;
  return (status || {}).new_ || row.isLocal;
};

var inherited = function inherited(value, inheritedValue, canInherit) {
  if (canInherit && utils.isNullValue(value) && !utils.isNullValue(inheritedValue)) {
    return React.createElement("div", {
      style: {
        color: "blue"
      }
    }, inheritedValue);
  }

  return value;
};

export var metaFunctions = {
  dataset: {
    actions: {
      exportMeta: function exportMeta(functionsObject) {
        return function (_ref2) {
          var meta = _ref2.meta,
              datasetFunctions = _ref2.datasetFunctions;
          // const excludes = {
          // 	serverPagination: true,
          // 	zoom: true,
          // 	indexRowId: true,
          // 	computedWidth: true,
          // 	rwd: true,
          // 	tp: true,
          // 	visibleIndexes: true,
          // 	statusDraggable: true,
          // 	visibleIndex_: true,
          // 	index_: true,
          // 	position: true
          // };
          var r = buildFunctionsObject(meta, functionsObject, [{
            path: "../demo/dataset.functions",
            object: datasetFunctions
          }]); // const r =
          // 	"userMeta = {meta : " +
          // 	JSON.stringify(buildObject(meta, excludes)) +
          // 	"," +
          // 	functions;
          // functions
          // 	.slice(1, functions.length - 1)
          // 	.replace(/\\"/g, '"') +
          // ";";
          // console.log(meta, r);

          utils.exportFile(r, "meta.txt", "text");
          return r;
        };
      }
    }
  },
  properties: {
    accessors: {
      propertyType: function propertyType(_ref3) {
        var row = _ref3.row,
            status = _ref3.status,
            meta = _ref3.meta;

        if (row.reference) {
          return row.reference;
        } else if (row.analytic) {
          return "analytic";
        } else if (row.accessor || (status || {}).new_) {
          return "computed";
        } else {
          return "dataset";
        }
      }
    },
    sorts: {},
    formats: {
      isArrayOrFunction: function isArrayOrFunction(_ref4) {
        var value = _ref4.value;

        if (typeof value === "function" || Array.isArray(value)) {
          return React.createElement("div", {
            style: {
              backgroundColor: "#f5f7da",
              fontStyle: "italic"
            }
          }, Array.isArray(value) ? "array[]" : "fct()");
        }

        return value;
      }
    },
    aggregations: {},
    selects: {},
    validators: {
      row: function row(_ref5) {
        var _row = _ref5.row,
            status = _ref5.status,
            data = _ref5.data,
            params = _ref5.params;
      }
    },
    editables: {
      isDataset: function isDataset(_ref6) {
        var row = _ref6.row;
        return row.tp === "Dataset";
      },
      isNotDataset: function isNotDataset(_ref7) {
        var row = _ref7.row;
        return row.tp !== "Dataset";
      },
      isAnalytic: function isAnalytic(_ref8) {
        var row = _ref8.row;
        return row.tp === "Analytic";
      }
    },
    defaults: {},
    row: function row() {},
    table: function table() {}
  },
  functions: {
    accessors: {
      functionDescriptor: function functionDescriptor(_ref9) {
        var row = _ref9.row;
        var label;

        if (row.tp === "accessor") {
          label = "Parameters: ({row,status,data,params,utils})";
        } else if (row.tp === "editable") {
          label = "Parameters: ({row,status,data,params})";
        } else if (row.tp === "select") {
          label = "Parameters: ({row,status,data,params})";
        } else if (row.tp === "validator") {
          label = "Parameters: ({row,status,data,params})";
        } else if (row.tp === "format") {
          label = "Parameters: (value,row,status,data,params)";
        } else if (row.tp === "aggregation") {
          label = "Parameters: ([values])";
        } else if (row.tp === "sort") {
          label = "Parameters: (rowA, rowB)";
        } else if (row.tp === "window") {
          label = "Parameters: (value)";
        }

        return "".concat(row.caption || row.id, " : ").concat(label);
      },
      isLocal: isLocal
    },
    validators: {
      stringToFunction: stringToFunction
    },
    actions: {
      exportFunctions: function exportFunctions(_ref10) {
        var data = _ref10.data;
        return "functions = " + buildFunctionsObject(data);
      }
    },
    editables: {
      isLocal: isLocal
    }
  },
  dimensions: {
    accessors: {
      sortAcc: function sortAcc(_ref11) {
        var row = _ref11.row;
        return (row.sort || {}).keyAccessor;
      },
      sortFct: function sortFct(_ref12) {
        var row = _ref12.row;
        return (row.sort || {}).custom;
      },
      isLocal: isLocal
    },
    validators: {
      sortAcc: function sortAcc(_ref13) {
        var row = _ref13.row;
        return row.sort = _objectSpread({}, row.sort || {}, {
          keyAccessor: row.sortAccessor
        });
      },
      sortFct: function sortFct(_ref14) {
        var row = _ref14.row;
        return row.sort = _objectSpread({}, row.sort || {}, {
          custom: row.sortFunction
        });
      }
    },
    editables: {
      isLocal: isLocal
    }
  },
  measures: {
    accessors: {
      isLocal: isLocal
    },
    editables: {
      isLocal: isLocal
    }
  },
  globals_: {
    editables: {
      is_selected: function is_selected(_ref15) {
        var row = _ref15.row;
        return row.index_ !== undefined;
      },
      is_new: function is_new(_ref16) {
        var status = _ref16.status;
        return status.new_;
      }
    },
    observers: {
      onNext: onNext,
      onCompleted: onCompleted,
      onError: onError
    },
    validators: {
      overwrite: function overwrite(x) {
        return true;
      }
    }
  }
};
export var setPropertyAccessors = function setPropertyAccessors(properties, data) {
  var accessors = {};
  properties.forEach(function (property) {
    accessors[property.id] = {
      id: "row.".concat(property.id),
      caption: "".concat(property.id),
      type: "property"
    };

    if (data && (property.dataType === "object" || property.dataType === "joined object")) {
      data.forEach(function (row) {
        if (!utils.isNullValue(row[property.id])) {
          Object.keys(row[property.id]).forEach(function (key) {
            accessors[property.id + "." + key] = {
              id: "row.".concat(property.id, ".").concat(key),
              caption: "".concat(property.id, ".").concat(key),
              type: "object property"
            };
          });
        }
      });
    }
  });
  propertyAccessors = accessors;
};
var propertyAccessors = {};
export var metaDescriptions = function metaDescriptions(object, source, functions) {
  var callbacks = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

  var getFunctions = function getFunctions(type) {
    return functions.getFunctionsArray(object, type, source).reduce(function (acc, f) {
      acc[f.id] = {
        id: f.id,
        caption: f.caption || f.id,
        type: "function",
        style: {
          color: "blue"
        }
      };
      return acc;
    }, {});
  };

  var getAccessorsAndProperties = function getAccessorsAndProperties() {
    var dataAccessors = propertyAccessors;
    var accessors = getFunctions("accessors");
    return _objectSpread({}, dataAccessors, accessors);
  };

  var getAggregations = function getAggregations() {
    return getFunctions("aggregations");
  };

  var getFormats = function getFormats() {
    return getFunctions("formats");
  };

  var getSorts = function getSorts() {
    return getFunctions("sorts");
  };

  var getWindowFunctions = function getWindowFunctions() {
    return getFunctions("windows");
  };

  var getSelects = function getSelects() {
    return getFunctions("selects");
  };

  var getValidators = function getValidators() {
    return getFunctions("validators");
  };

  var getDefaults = function getDefaults() {
    return getFunctions("defaults");
  };

  var getAnalytics = function getAnalytics() {
    return getFunctions("analytics");
  };

  var getForeignObjects = function getForeignObjects() {
    return getFunctions("foreignObjects");
  };

  return {
    dataset: {
      table: {
        object: "dataset",
        editable: true,
        noFilter: false,
        // caption: "Dataset",
        actions: [{
          type: "insert",
          caption: "New",
          enable: true,
          key: "f2"
        }, {
          type: "delete",
          caption: "Delete",
          enable: "is_selected",
          key: "f3"
        }, {
          type: "duplicate",
          caption: "Duplicate",
          enable: "is_selected",
          key: "f4"
        }, {
          type: "save",
          caption: "Save",
          enable: true,
          key: "f12"
        }, {
          type: "refresh",
          caption: "Refresh",
          enable: true,
          key: "10"
        }, {
          type: "action",
          enable: true,
          hidden: true,
          action: "toggleFilter",
          key: "f11"
        }, {
          type: "action",
          caption: "Export Meta",
          enable: true,
          action: "exportMeta"
        }]
      },
      row: {},
      properties: []
    },
    properties: {
      table: {
        object: "properties",
        editable: true,
        primaryKey: "id",
        code: "caption",
        noDataMutation: true,
        onSave: callbacks.applyProperties,
        actions: [{
          type: "insert",
          caption: "New",
          enable: true,
          key: "f2"
        }, {
          type: "delete",
          caption: "Delete",
          enable: "isNotDataset",
          key: "f3"
        }, {
          type: "duplicate",
          caption: "Duplicate",
          enable: "is_selected",
          key: "f4"
        }, {
          type: "action",
          enable: true,
          hidden: true,
          action: "toggleFilter",
          key: "f11"
        }, {
          type: "save",
          caption: "Apply",
          enable: true,
          key: "f12"
        }]
      },
      row: {},
      properties: [{
        id: "id",
        caption: "Column",
        width: 100,
        dataType: "string",
        editable: "isNotDataset",
        mandatory: true,
        locked: true
      }, {
        id: "tp",
        caption: "Type",
        width: 150,
        dataType: "string",
        editable: false,
        default: "Computed",
        accessor: "propertyType",
        filterType: "values"
      }, {
        id: "dataType",
        caption: "Data type",
        width: 100,
        dataType: "string",
        editable: "isNotDataset",
        filterType: "values",
        select: ["number", "string", "text", "date", "boolean", "object", "joined object"]
      }, {
        id: "caption",
        caption: "Caption",
        width: 150,
        dataType: "string",
        editable: true
      }, {
        id: "editable",
        caption: "Editable",
        width: 80,
        dataType: "boolean",
        editable: true,
        default: false
      }, {
        id: "mandatory",
        caption: "Mandatory",
        width: 90,
        dataType: "boolean",
        editable: true,
        default: true
      }, {
        id: "hidden",
        caption: "Hidden",
        width: 80,
        dataType: "boolean",
        editable: true,
        default: false
      }, {
        id: "width",
        caption: "Width",
        width: 60,
        dataType: "number",
        editable: true,
        default: 100
      }, {
        id: "format",
        caption: "Format",
        width: 100,
        dataType: "string",
        editable: true,
        filterType: "values",
        select: getFormats
      }, {
        id: "filterType",
        caption: "Filter",
        width: 100,
        dataType: "string",
        editable: true,
        select: ["starts", "starts (case sensitive)", "contains", "=", ">=", "<=", "between", "values"]
      }, // only for new properties
      {
        id: "accessor",
        caption: "Accessor",
        width: 150,
        dataType: "string",
        editable: "isNotDataset",
        hidden: false,
        filterType: "values",
        select: getAccessorsAndProperties,
        format: "isArrayOrFunction"
      }, {
        id: "select",
        caption: "Select",
        width: 100,
        dataType: "string",
        editable: true,
        filterType: "values",
        select: getSelects,
        format: "isArrayOrFunction"
      }, {
        id: "default",
        caption: "Default",
        width: 100,
        dataType: "string",
        editable: true,
        // hidden: true,
        filterType: "values",
        select: getDefaults
      }, {
        id: "foreignObject",
        caption: "Foreign object",
        width: 150,
        dataType: "string",
        editable: true,
        select: getForeignObjects,
        format: "isArrayOrFunction"
      }, {
        id: "analytic",
        caption: "Analytic function",
        width: 150,
        dataType: "string",
        editable: true,
        select: getAnalytics,
        format: "isArrayOrFunction"
      }, {
        id: "onChange",
        caption: "On change",
        width: 100,
        dataType: "string",
        editable: true,
        filterType: "values",
        select: getValidators,
        format: "isArrayOrFunction"
      }, {
        id: "onQuit",
        caption: "On cell quit",
        width: 100,
        dataType: "string",
        editable: true,
        filterType: "values",
        select: getValidators,
        format: "isArrayOrFunction"
      }]
    },
    functions: {
      table: {
        object: "functions",
        editable: true,
        primaryKey: "id",
        code: "caption",
        onSave: callbacks.applyFunctions,
        actions: [{
          type: "insert",
          caption: "New",
          enable: true,
          key: "f2"
        }, {
          type: "delete",
          caption: "Delete",
          enable: "isLocal",
          key: "f3"
        }, {
          type: "duplicate",
          caption: "Duplicate",
          enable: "is_selected",
          key: "f4"
        }, {
          type: "save",
          caption: "Apply",
          enable: true,
          hidden: !callbacks.applyFunctions,
          key: "f12"
        }, {
          type: "action",
          caption: "Export functions",
          action: "exportFunctions",
          hidden: true
        }, {
          type: "action",
          enable: true,
          hidden: true,
          action: "toggleFilter",
          key: "f11"
        }]
      },
      row: {
        descriptor: "functionDescriptor"
      },
      properties: [{
        id: "id",
        caption: "Code",
        width: 100,
        dataType: "string",
        editable: "isLocal",
        mandatory: true,
        locked: true
      }, {
        id: "caption",
        caption: "Caption",
        width: 150,
        dataType: "string",
        editable: true,
        filterType: "between"
      }, {
        id: "visibility",
        caption: "Visibility",
        width: 150,
        dataType: "string",
        editable: "isLocal",
        select: source ? [object, source, "globals_"] : [object, "globals_"],
        filterType: "values",
        mandatory: true,
        default: "global"
      }, {
        id: "tp",
        caption: "Type",
        width: 150,
        dataType: "string",
        editable: "isLocal",
        filterType: "values",
        select: ["actions", "accessors", "aggregations", "formats", "sorts", "windows", "selects", "validators", "editables", "defaults", "descriptors", "dmls"]
      }, {
        id: "isLocal",
        caption: "Local",
        accessor: "isLocal",
        width: 80,
        dataType: "boolean",
        default: true
      }, {
        id: "functionText",
        caption: "Function",
        // accessor: "functionToString",
        onQuit: function onQuit(_ref17) {
          var row = _ref17.row;
          return stringToFunction(row, functions);
        },
        width: 500,
        dataType: "text",
        editable: "isLocal"
      }, {
        id: "functionJS",
        caption: "Function",
        // accessor: "functionToString",
        // onQuit: "stringToFunction",
        hidden: true
      }]
    },
    measures: {
      table: {
        object: "measures",
        editable: true,
        primaryKey: "id",
        code: "caption",
        onSave: callbacks.applyMeasures,
        actions: [{
          type: "insert",
          caption: "New",
          enable: true,
          key: "f2"
        }, {
          type: "delete",
          caption: "Delete",
          enable: "is_selected",
          key: "f3"
        }, {
          type: "duplicate",
          caption: "Duplicate",
          enable: "is_selected",
          key: "f4"
        }, {
          type: "save",
          caption: "Apply",
          enable: true,
          key: "f12"
        }, {
          type: "action",
          enable: true,
          hidden: true,
          action: "toggleFilter",
          key: "f11"
        }]
      },
      row: {},
      properties: [{
        id: "id",
        caption: "id",
        width: 100,
        dataType: "string",
        editable: "isLocal",
        mandatory: true
      }, {
        id: "caption",
        caption: "caption",
        width: 150,
        dataType: "string",
        editable: true
      }, {
        id: "valueAccessor",
        caption: "Value accessor",
        width: 150,
        dataType: "string",
        editable: "isLocal",
        mandatory: true,
        filterType: "values",
        select: getAccessorsAndProperties
      }, {
        id: "localFormat",
        caption: "format",
        width: 150,
        dataType: "string",
        editable: true,
        filterType: "values",
        select: getFormats,
        accessor: function accessor(_ref18) {
          var row = _ref18.row;
          return utils.nullValue(row.localFormat, row.format);
        },
        onQuit: "overwrite",
        format: function format(_ref19) {
          var value = _ref19.value,
              row = _ref19.row;
          return inherited(row.localFormat, row.format);
        }
      }, {
        id: "aggregation",
        caption: "aggregation",
        width: 150,
        dataType: "string",
        editable: "isLocal",
        mandatory: true,
        default: "sum",
        filterType: "values",
        select: getAggregations
      }, {
        id: "isLocal",
        caption: "Local",
        accessor: "isLocal",
        width: 80,
        dataType: "boolean",
        default: true
      }]
    },
    dimensions: {
      table: {
        object: "dimensions",
        editable: true,
        primaryKey: "id",
        code: "caption",
        onSave: callbacks.applyDimensions,
        actions: [{
          type: "insert",
          caption: "New",
          enable: true,
          key: "f2"
        }, {
          type: "delete",
          caption: "Delete",
          enable: "is_selected",
          key: "f3"
        }, {
          type: "duplicate",
          caption: "Duplicate",
          enable: "is_selected",
          key: "f4"
        }, {
          type: "save",
          caption: "Apply",
          // action: callbacks.applyDimensions,
          enable: true,
          key: "f12"
        }, {
          type: "action",
          enable: true,
          hidden: true,
          action: "toggleFilter",
          key: "f11"
        }]
      },
      row: {},
      properties: [{
        id: "id",
        caption: "Dimension",
        width: 100,
        dataType: "string",
        editable: "isLocal"
      }, {
        id: "caption",
        caption: "Caption",
        width: 150,
        dataType: "string",
        editable: true
      }, {
        id: "keyAccessor",
        caption: "Key accessor",
        width: 150,
        dataType: "string",
        editable: "isLocal",
        filterType: "values",
        select: getAccessorsAndProperties
      }, {
        id: "localLabelAccessor",
        caption: "Label accessor",
        width: 150,
        dataType: "string",
        editable: "isLocal",
        select: getAccessorsAndProperties,
        accessor: function accessor(_ref20) {
          var row = _ref20.row;
          return utils.nullValue(row.localLabelAccessor, row.labelAccessor);
        },
        onQuit: "overwrite",
        format: function format(_ref21) {
          var value = _ref21.value,
              row = _ref21.row;
          return inherited(row.localLabelAccessor, row.labelAccessor, !row.isLocal);
        }
      }, {
        id: "sort",
        caption: "sort",
        width: 100,
        dataType: "object",
        hidden: true,
        editable: true
      }, {
        id: "localSortAccessor",
        caption: "Sort accessor",
        width: 150,
        dataType: "string",
        editable: true,
        filterType: "values",
        select: getAccessorsAndProperties,
        accessor: function accessor(_ref22) {
          var row = _ref22.row;
          return utils.nullValue(row.sort.localKeyAccessor, row.sort.keyAccessor);
        },
        onQuit: function onQuit(_ref23) {
          var row = _ref23.row;

          if (!row.sort) {
            row.sort = {};
          }

          row.sort.localKeyAccessor = row.localSortAccessor;
          return true;
        },
        format: function format(_ref24) {
          var row = _ref24.row;
          return inherited(row.sort.localKeyAccessor, row.sort.keyAccessor, !row.isLocal);
        }
      }, {
        id: "localSortFunctionAccessor",
        caption: "Sort function",
        width: 150,
        dataType: "string",
        editable: true,
        filterType: "values",
        select: getSorts,
        accessor: function accessor(_ref25) {
          var row = _ref25.row;
          return utils.nullValue(row.sort.localOrderFunctionAccessor, row.sort.orderFunctionAccessor);
        },
        onQuit: function onQuit(_ref26) {
          var row = _ref26.row;

          if (!row.sort) {
            row.sort = {};
          }

          row.sort.localOrderFunctionAccessor = row.localSortFunctionAccessor;
          return true;
        },
        format: function format(_ref27) {
          var value = _ref27.value,
              row = _ref27.row;
          return inherited(row.sort.localOrderFunctionAccessor, row.sort.orderFunctionAccessor, !row.isLocal);
        }
      }, {
        id: "localFormat",
        caption: "format",
        width: 150,
        dataType: "string",
        editable: true,
        filterType: "values",
        select: getFormats,
        accessor: function accessor(_ref28) {
          var row = _ref28.row;
          return utils.nullValue(row.localFormat, row.format);
        },
        onQuit: "overwrite",
        format: function format(_ref29) {
          var value = _ref29.value,
              row = _ref29.row;
          return inherited(row.localFormat, row.format, !row.isLocal);
        }
      }, {
        id: "isLocal",
        caption: "Local",
        accessor: "isLocal",
        width: 80,
        dataType: "boolean",
        default: true
      }]
    }
  };
};