import _classCallCheck from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/classCallCheck";
import _createClass from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/getPrototypeOf";
import _inherits from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/inherits";
import React from "react";
import classnames from "classnames";
import { ScrollableGrid, utils, Input } from "zebulon-controls";
import { cellData } from "./utils/compute.data";
export var Rows =
/*#__PURE__*/
function (_ScrollableGrid) {
  _inherits(Rows, _ScrollableGrid);

  function Rows() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Rows);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Rows)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.cell = function (tableEditable, row, column, status, data, params, style, focused, hasFocus, selected, onMouseDown, onMouseUp, onMouseOver, onChange, onFocus, rowIndex, onDoubleClick, componentId) {
      var _cellData = cellData(row, column, status, data, params, focused),
          editable = _cellData.editable,
          value = _cellData.value,
          select = _cellData.select,
          dataType = _cellData.dataType;

      var className = classnames({
        "zebulon-table-cell": true,
        "zebulon-table-cell-odd": rowIndex % 2 === 1,
        "zebulon-table-cell-selected": selected,
        "zebulon-table-cell-focused": focused,
        "zebulon-table-cell-editable": editable && focused,
        "zebulon-table-cell-select": editable && focused && select,
        "zebulon-table-cell-checkbox": dataType === "boolean"
      });
      var id = "cell: ".concat(componentId, "-").concat(row.index_, "-").concat(column.index_);

      if (focused && hasFocus && editable) {
        _this.focused = id;
      }

      return React.createElement(Input, {
        row: row,
        column: column,
        style: style,
        className: className,
        value: value,
        editable: editable && tableEditable,
        focused: focused,
        hasFocus: hasFocus,
        select: select,
        dataType: dataType,
        inputType: "cell",
        id: id,
        key: id,
        onChange: onChange,
        onMouseDown: onMouseDown,
        onMouseUp: onMouseUp,
        onMouseOver: onMouseOver,
        onFocus: onFocus,
        onDoubleClick: onDoubleClick ? function (e) {
          return onDoubleClick(e, row, column);
        } : function () {},
        menu: "cell-menu",
        component: componentId
      });
    };

    _this.rowRenderer = function (tableEditable, row, status, meta, startIndex, shift, visibleWidth, rowHeight, rowIndex, hasFocus, componentId) {
      var cells = [];
      var left = shift,
          index = startIndex;

      var selectedRange = _this.selectedRange();

      while (index < meta.length && left < visibleWidth) {
        var column = meta[index];

        if (!column.hidden) {
          (function () {
            var textAlign = column.alignement || "left";

            if (!column.alignement) {
              if (column.dataType === "number") {
                textAlign = "right";
              } else if (column.dataType === "date" || column.dataType === "month" || column.dataType === "year" || column.dataType === "boolean") {
                textAlign = "center";
              }
            }

            var columnIndex = index;

            var selected = utils.isInRange({
              columns: index,
              rows: rowIndex
            }, selectedRange.start, selectedRange.end),
                focused = selectedRange.end.rows === rowIndex && selectedRange.end.columns === index,
                onMouseDown = function onMouseDown(e) {
              // e.preventDefault();
              _this.selectCell({
                rows: rowIndex,
                columns: columnIndex
              }, e.shiftKey, false);
            },
                onMouseOver = function onMouseOver(e) {
              if ((e.buttons & 1) === 1 && !(_this.noOver || _this.props.openedFilter)) {
                // e.preventDefault();
                _this.selectCell({
                  rows: rowIndex,
                  columns: columnIndex
                }, false);
              }
            },
                onMouseUp = function onMouseUp(e) {
              // e.preventDefault();
              _this.mouseDown = false;
            };

            cells.push(_this.cell(tableEditable, row, column, status, _this.props.data, _this.props.params, {
              position: "absolute",
              //, toto
              left: left,
              width: Math.min(false ? column.computedWidth + shift : column.computedWidth, visibleWidth - left),
              height: rowHeight,
              textAlign: textAlign
            }, focused, hasFocus && focused, selected, onMouseDown, onMouseUp, onMouseOver, _this.props.onChange, _this.props.onFocus, rowIndex, _this.props.onDoubleClick, componentId));
            left += column.computedWidth;
          })();
        }

        index += 1;
      }

      return React.createElement("div", {
        key: rowIndex,
        id: rowIndex,
        style: {
          display: "flex",
          height: rowHeight
        }
      }, cells);
    };

    _this.getContent = function () {
      // this.noOver = true;
      var items = [];
      var _this$props = _this.props,
          data = _this$props.data,
          meta = _this$props.meta,
          height = _this$props.height,
          rowHeight = _this$props.rowHeight,
          width = _this$props.width,
          updatedRows = _this$props.updatedRows,
          hasFocus = _this$props.hasFocus,
          componentId = _this$props.componentId,
          locked = _this$props.locked; // console.log("render rows", locked, this.selectedRange(), meta);

      var i = 0,
          index = _this.props.scroll.rows.startIndex,
          indexPage = 0,
          rows = data,
          columnStartIndex = _this.props.scroll.columns.startIndex,
          columnShift = _this.props.scroll.columns.shift;

      if (typeof data === "object" && data.page) {
        rows = data.page;
        indexPage = data.pageStartIndex;
      }

      var visibleWidth = width - _this.scrollbars.vertical.width;

      if (!_this.props.noVerticalScrollbar) {
        columnStartIndex = Math.max(columnStartIndex, utils.isNullOrUndefined(meta.lockedIndex) ? 0 : meta.lockedIndex + 1);
      } else {
        columnStartIndex = 0;
        columnShift = 0;
      }

      while (index < rows.length && i < height / rowHeight) {
        var row = rows[index - indexPage];
        var status = updatedRows[row.index_];

        if (meta.serverPagination && status && status.rowUpdated) {
          row = status.rowUpdated;
        }

        items.push(_this.rowRenderer(meta.table.editable, row, status, meta.properties, columnStartIndex, columnShift, visibleWidth, rowHeight, index, hasFocus, componentId));
        index++;
        i++;
      }

      var style = {
        top: _this.props.scroll.rows.shift || 0,
        width: visibleWidth,
        position: "inherit",
        height: "inherit"
      };
      console.log("render row");
      return React.createElement("div", {
        id: "content",
        style: style,
        onWheel: _this.onWheel,
        className: locked ? "zebulon-locked-columns" : ""
      }, items);
    };

    return _this;
  }

  _createClass(Rows, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return !nextProps.status.loadingPage && !nextProps.noUpdate;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      // if (this.focused) {
      //   // console.log("focus", this.focused, this.props.hasFocus);
      //   // document.getElementById(this.focused).focus();
      //   // document.getElementById(this.focused).children[0].focus();
      //   this.focused = undefined;
      // }
      this.noOver = false;
    }
  }]);

  return Rows;
}(ScrollableGrid);