import _defineProperty from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/defineProperty";
import _objectSpread from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/objectSpread";
import _classCallCheck from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/classCallCheck";
import _possibleConstructorReturn from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/getPrototypeOf";
import _inherits from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/inherits";
import { TableEvent } from "./Table.events";
import { utils } from "zebulon-controls";
import { filtersFunction, getSorts, sortsFunction } from "./utils/filters.sorts";
export var TableFilterSort =
/*#__PURE__*/
function (_TableEvent) {
  _inherits(TableFilterSort, _TableEvent);

  function TableFilterSort() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, TableFilterSort);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(TableFilterSort)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.adjustScrollRows = function (filteredData) {
      if (_this.state) {
        var _this$state = _this.state,
            selectedRange = _this$state.selectedRange,
            scroll = _this$state.scroll,
            meta = _this$state.meta;
        var _this$props = _this.props,
            componentId = _this$props.componentId,
            id = _this$props.id; // let { rows, columns } = scroll;

        if (!filteredData.length) {
          selectedRange.end = {};
          selectedRange.start = {};
          _this.hasFocus = false;
          _this.bLoaded = undefined;
          var column = meta.properties[(meta.visibleIndexes || [0])[0]];
          var element = document.getElementById("filter: ".concat(componentId || id, "--").concat(column.index_, "-"));

          if (element && element.children[0]) {
            element.children[0].focus();
          }
        } else if (selectedRange.end.rows === undefined) {
          var columns = (meta.visibleIndexes || [0])[0];
          selectedRange.end = {
            rows: 0,
            columns: columns
          };
          selectedRange.start = {
            rows: 0,
            columns: columns
          };
          _this.bLoaded = true;

          _this.scrollTo(selectedRange.end.rows, 1, selectedRange.end.columns, scroll.columns.direction, false, filteredData.length);

          _this.setState({
            scroll: _objectSpread({}, scroll)
          });
        } else if (selectedRange.end.rows > filteredData.length - 1) {
          selectedRange.end.rows = filteredData.length - 1;

          _this.scrollTo(0, -1, selectedRange.end.columns, scroll.columns.direction, false, filteredData.length);
        } else if (scroll.rows.index + _this.rowsHeight / _this.rowHeight > filteredData.length - 1) {
          _this.scrollTo(selectedRange.end.rows, scroll.rows.direction, selectedRange.end.columns, scroll.columns.direction, false, filteredData.length);
        } else {
          _this.setState({
            scroll: _objectSpread({}, scroll)
          });
        }

        _this.selectRange(selectedRange, undefined, filteredData[selectedRange.end.rows], "enter");

        _this.row = filteredData[selectedRange.end.rows];
        return _this.row;
      }
    };

    _this.filters = function (data, filters, noFocus, updatedRows) {
      if (!Array.isArray(data)) {
        return [];
      }

      var filter = filtersFunction(filters, _this.props.params, data, updatedRows);
      var filteredData = data.filter(filter);

      if (_this.props.onFilter) {
        _this.props.onFilter({
          filters: filters,
          filteredData: filteredData,
          data: data,
          params: _this.props.params,
          updatedRows: updatedRows
        });
      }

      return filteredData;
    };

    _this.getFilterItems = function (filter, column) {
      var _this$state2 = _this.state,
          meta = _this$state2.meta,
          updatedRows = _this$state2.updatedRows;
      var data = _this.props.data; // if (!meta.serverPagination) {

      if (!filter || !filter.items) {
        if (meta.table.filteredByServer && column.selectItems) {
          if (utils.isMap(column.selectItems)) {
            data = Array.from(column.selectItems).map(function (row) {
              return row[1];
            });
          } else if (utils.isObject(column.selectItems)) {
            data = Object.values(column.selectItems);
          } else {
            data = column.selectItems;
          }

          if (column.reference) {
            data = data.map(function (row) {
              return _defineProperty({}, column.reference, row);
            });
          }
        }

        var items = {};
        data.forEach(function (row) {
          var id = (column.foreignKeyAccessorFunction || column.accessorFunction || function (_ref2) {
            var row = _ref2.row;
            return row[column.id];
          })({
            row: row,
            column: column,
            status: updatedRows[row.index_],
            params: _this.props.params,
            data: data
          }),
              label = (column.accessorFunction || function (_ref3) {
            var row = _ref3.row;
            return row[column.id];
          })({
            row: row,
            column: column,
            status: updatedRows[row.index_],
            params: _this.props.params,
            data: data
          }),
              sort = id,
              nvl = ""; // a voir status


          if (typeof (id || undefined) === "object") {
            label = id.caption;
            sort = id.caption;
            id = id.value;
          } else {
            label = (column.formatFunction || function (_ref4) {
              var value = _ref4.value;
              return utils.formatValue(value, null, column.decimals);
            })({
              value: label,
              column: column,
              row: row,
              params: _this.props.params,
              status: updatedRows[row.index_],
              data: data
            });
          }

          if (column.dataType === "date") {
            nvl = new Date(null);
          } else if (column.dataType === "number") {
            nvl = -Infinity;
          }

          items[id] = {
            id: id,
            label: label,
            sort: sort || nvl
          };
        });
        column.items = Object.values(items);
        column.items.sort(function (itemA, itemB) {
          return (itemA.sort > itemB.sort) - (itemA.sort < itemB.sort);
        });
        filter = column; // }
      } // else {
      //   column.items = [];
      //   filter = column;
      // }


      return filter;
    };

    _this.openFilter = function (e, column) {
      if (_this.isOpening) {
        return;
      }

      var filter = _this.state.filters[column.id];
      filter = _this.getFilterItems(filter, column); // filter.top = this.rowHeight + (this.state.meta.table.caption ? 30 : 0); // e.target.offsetParent.offsetTop; //this.nFilterRows * this.rowHeight;

      var rect = e.target.getBoundingClientRect();
      var rectTable = document.getElementById("table-".concat(_this.props.id)).getBoundingClientRect();
      filter.top = rect.y - rectTable.y;
      filter.left = rect.x - rectTable.x; //+ window.scrollX;
      // filter.left = e.target.offsetLeft;

      var ok = _this.canQuit("rowQuit", function (ok) {
        if (ok) {
          return _this.openFilter_(e, column, filter);
        }
      });

      if (ok) {
        return _this.openFilter_(e, column, filter);
      }
    };

    _this.openFilter_ = function (e, column, filter) {
      if (column.filterType !== "values") {
        // e.target.focus();
        _this.hasFocus = false;
        return _this.closeOpenedWindows();
      }

      e.preventDefault();
      e.stopPropagation();
      e.persist(); // column.position + this.rowHeight - this.state.scroll.columns.position;
      // console.log("filtersort", this.hasFocus);

      _this.hasFocus = false;

      _this.setState({
        openedFilter: column.id,
        filters: _objectSpread({}, _this.state.filters, _defineProperty({}, column.id, filter))
      });
    };

    _this.onChangeFilter = function (_ref5) {
      var value = _ref5.value,
          row = _ref5.row,
          column = _ref5.column,
          filterTo = _ref5.filterTo;

      if (_this.state.status.loaded) {
        var ok = _this.props.onTableChange("filter", function (ok) {
          if (ok) {
            _this.onChangeFilter_(value, row, column, filterTo);
          }
        });

        if (ok) {
          _this.onChangeFilter_(value, row, column, filterTo);
        }
      }
    };

    _this.onChangeFilter_ = function (value, row, column, filterTo) {
      var _this$state3 = _this.state,
          selectedRange = _this$state3.selectedRange,
          filters = _this$state3.filters,
          meta = _this$state3.meta,
          data = _this$state3.data,
          updatedRows = _this$state3.updatedRows; // const ok = this.selectRange(selectedRange, undefined, this.row, "quit");
      // return false;

      _this.closeOpenedWindows();

      var v = value;

      if (v.value === undefined) {
        return;
      }

      if (v !== column.v && !filterTo || v !== column.vTo && filterTo) {
        _this.hasFocus = false;

        if (column.filterType === "between" && filterTo) {
          column.vTo = v;
        } else {
          column.v = v;
        }

        filters[column.id] = column; // this.changingFilter = true;

        var filteredData = _this.filters(data, filters, true, updatedRows); // if (!meta.serverPagination) {


        _this.sorts(filteredData, meta.properties);

        _this.setState({
          filteredData: filteredData
        });

        _this.selectRange(selectedRange, undefined, _this.adjustScrollRows(filteredData), "enter", true); // }

      }
    };

    _this.onChangeFilterValues = function (filter) {
      var openedFilter = _this.state.openedFilter;

      _this.setState({
        openedFilter: undefined
      });

      var ok = _this.props.onTableChange("filter", function (ok) {
        if (ok) {
          _this.onChangeFilterValues_(openedFilter, filter);
        }
      });

      if (ok) {
        _this.onChangeFilterValues_(openedFilter, filter);
      }
    };

    _this.onChangeFilterValues_ = function (openedFilter, filter) {
      var _this$state4 = _this.state,
          filters = _this$state4.filters,
          meta = _this$state4.meta,
          data = _this$state4.data;
      var column = filters[openedFilter];
      column.v = filter;
      filters[column.id] = column;

      var filteredData = _this.filters(data, filters); // if (!meta.serverPagination) {


      _this.sorts(filteredData, meta.properties);

      _this.setState({
        filteredData: filteredData
      });

      _this.selectRange(_this.range, undefined, _this.adjustScrollRows(filteredData), "enter", true); // }

    };

    _this.sorts = function (data, columns) {
      var sorts = getSorts(columns);

      if (!Array.isArray(data)) {
        if (_this.state && _this.state.meta.serverPagination) {
          return _this.pagination({
            sorts: sorts,
            callbackAfter: function callbackAfter() {
              _this.selectRange_(_this.range, undefined, undefined, "enter", _this.hasFocus);
            }
          });
        }

        return [];
      }

      if (sorts.length) {
        data.sort(sortsFunction(sorts));
      }

      if (_this.props.onSort) {
        _this.props.onSort({
          sorts: columns,
          filteredData: data,
          data: _this.props.data,
          params: _this.props.params
        });
      }
    };

    _this.onSort = function (column, doubleClick) {
      if (!_this.state.meta.table.noOrder) {
        var ok = _this.props.onTableChange("sort", function (ok) {
          if (ok) {
            _this.onSort_(column, doubleClick);
          }
        });

        if (ok) {
          _this.onSort_(column, doubleClick);
        }
      }
    };

    _this.onSort_ = function (column, doubleClick) {
      var _this$state5 = _this.state,
          filteredData = _this$state5.filteredData,
          meta = _this$state5.meta;

      _this.closeOpenedWindows();

      if (_this.selectRange(_this.range, undefined, _this.row, "quit", _this.hasFocus) === false) {
        return false;
      }

      var columns = meta.properties;
      var sorts = [];
      columns.forEach(function (col) {
        if (doubleClick && col.id !== column.id) {
          col.sort = undefined;
          col.sortOrder = undefined;
        }

        if (col.id === column.id) {
          if (col.sort === undefined) {
            col.sort = "asc";
          } else if (col.sort === "asc") {
            col.sort = "desc";
          } else if (col.sort === "desc") {
            col.sort = undefined;
            col.sortOrder = undefined;
          }
        }

        if (col.sort !== undefined) {
          sorts.push({
            index: col.index_,
            sortOrder: col.sortOrder === undefined ? 1000 : col.sortOrder
          });
        }
      });
      sorts.sort(function (a, b) {
        return (a.sortOrder > b.sortOrder) - (b.sortOrder > a.sortOrder);
      });
      sorts.forEach(function (col, index) {
        return columns[col.index].sortOrder = index;
      });

      _this.sorts(filteredData, columns);

      if (!meta.serverPagination) {
        _this.selectRange(_this.range, undefined, undefined, "enter", _this.hasFocus);

        _this.setState({
          filteredData: filteredData
        });
      }
    };

    return _this;
  }

  return TableFilterSort;
}(TableEvent); // const dataStrings = computeRowSearch(this.state.data, this.state.meta, {});
//    const indexes = rowSearch(dataStrings, "22/02");