import _objectSpread from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/objectSpread";
import _classCallCheck from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/classCallCheck";
import _createClass from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/getPrototypeOf";
import _inherits from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/inherits";
import React, { Component } from "react";
import { utils, ContextualMenuClient, Input, icons, CheckBoxInput } from "zebulon-controls"; // import { Input } from "./Input";

import { computeMetaPositions } from "./utils/compute.meta";
import { cellData } from "./utils/compute.data";
import { getRowErrors, getRowStatus } from "./utils/utils";
import classnames from "classnames";

var filter = function filter(column, position, height, width, filterTo, onChange, openFilter, // focusedId,
componentId) {
  var className = classnames({
    "zebulon-table-cell": true,
    "zebulon-table-header": true,
    "zebulon-table-filter": true,
    "zebulon-table-filter-checkbox": column.dataType === "boolean",
    "zebulon-table-filter-checkbox-undefined": column.dataType === "boolean" && (!column.v || column.v.value === null)
  });
  var textAlign = column.alignement || "left";

  if (!column.alignement) {
    if (column.dataType === "number") textAlign = "right";else if (column.dataType === "date" || column.dataType === "month" || column.dataType === "year" || column.dataType === "boolean") textAlign = "center";
  }

  var id = "filter".concat(filterTo ? "To" : "", ": ").concat(componentId, "--").concat(column.index_);
  var focused = (document.activeElement || {}).id === id;
  var value = column.v,
      div;

  if (column.filterType === "values" && column.v) {
    div = React.createElement("div", {
      style: {
        height: height,
        width: width
      },
      id: id,
      key: id,
      className: className,
      onClick: function onClick(e) {
        return openFilter(e, column);
      }
    }, React.createElement("div", {
      style: {
        background: icons.filter,
        backgroundSize: "cover",
        height: "1em",
        width: "1em",
        marginTop: "0.1em",
        marginRight: "0.1em"
      }
    }));
  } else {
    if (filterTo) {
      value = column.vTo;
    } else if (column.filterType === "values") {
      value = "";
    }

    div = React.createElement(Input, {
      column: column,
      id: id + "-",
      key: id,
      className: className,
      style: {
        height: height,
        width: width,
        textAlign: textAlign
      },
      editable: true,
      focused: focused,
      inputType: "filter",
      tabIndex: column.index_ * 2 + (filterTo || 0) + 100,
      value: value === undefined ? null : value,
      filterTo: filterTo,
      onChange: onChange,
      onFocus: function onFocus(e) {
        openFilter(e, column);
      }
    });
  }

  return div;
};

var header = function header(column, position, height, width, handleClick, handleDragStart, handleDragOver, handleDrop, componentId // handleDragEnd
) {
  var sort = "";

  if (column.sort === "asc") {
    sort = "↑";
  } else if (column.sort === "desc") {
    sort = "↓";
  }

  var id = "header: ".concat(componentId, "--").concat(column.index_);
  return React.createElement(ContextualMenuClient, {
    key: id,
    id: id,
    className: "zebulon-table-cell zebulon-table-header",
    onClick: function onClick() {
      return handleClick(column, false);
    },
    onDoubleClick: function onDoubleClick() {
      return handleClick(column, true);
    },
    onDragOver: handleDragOver,
    onDrop: handleDrop,
    style: {
      height: height,
      width: width,
      justifyContent: "space-between",
      display: "flex",
      paddingRight: "unset"
    },
    column: column,
    menu: "column-header-menu",
    componentId: componentId
  }, React.createElement("div", {
    id: id,
    key: 0,
    style: {
      width: width - 15
    },
    draggable: true,
    onDragStart: function onDragStart(e) {
      return handleDragStart(e, "move");
    }
  }, column.caption || column.id), React.createElement("div", {
    id: id,
    key: 1,
    style: {
      width: 8
    }
  }, sort), React.createElement("div", {
    id: id,
    key: 2,
    style: {
      width: 6,
      cursor: "col-resize",
      opacity: 0
    },
    draggable: true,
    onDragStart: function onDragStart(e) {
      return handleDragStart(e, "resize");
    }
  }));
};

var auditCell = function auditCell(row, column, status, data, params, style, componentId) {
  var _cellData = cellData(row, column, status, data, params, false),
      value = _cellData.value;

  var textAlign = column.alignement || "left";

  if (!column.alignement) {
    if (column.dataType === "number") {
      textAlign = "right";
    } else if (column.dataType === "date" || column.dataType === "month" || column.dataType === "year" || column.dataType === "boolean") {
      textAlign = "center";
    }
  }

  style.textAlign = textAlign;
  var className = classnames({
    "zebulon-table-cell": true,
    "zebulon-table-cell-audit": true,
    "zebulon-table-cell-odd": true // "zebulon-table-cell-selected": selected,
    // "zebulon-table-cell-focused": focused,
    // "zebulon-table-cell-editable": editable && focused

  }); // if (column.dataType === "boolean") value = value || false;

  var id = "audit-cell: ".concat(componentId, "-").concat(row.index_, "-").concat(column.index_);
  return React.createElement(Input, {
    row: row,
    column: column,
    style: style,
    className: className,
    value: value,
    key: id,
    id: id
  });
};

var filterEmpty = function filterEmpty(id, position, width, height) {
  return React.createElement("div", {
    key: "".concat(id, "-filter-empty"),
    className: "zebulon-table-cell zebulon-table-header zebulon-table-filter-empty",
    style: {
      height: height,
      width: width // ,
      // border: "0.02em solid rgba(0, 0, 0, 0.2) ",
      // borderRight

    }
  });
}; // ↑↓


export var Headers =
/*#__PURE__*/
function (_Component) {
  _inherits(Headers, _Component);

  function Headers() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Headers);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Headers)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.handleClick = function (column, double) {
      if (!_this.props.isActive && _this.props.onActivation) {
        _this.props.onActivation(_this.props.componentId);
      }

      var onSort = _this.props.onSort;

      if (!double) {
        _this.timer = setTimeout(function () {
          if (!_this.prevent) {
            onSort(column, false);
          }

          _this.prevent = false;
        }, 200);
      } else {
        clearTimeout(_this.timer);
        _this.prevent = true;
        onSort(column, true);
      }
    };

    _this.getColumnIndex = function (id) {
      var ids = id.split("-");
      return ids[ids.length - 1];
    };

    _this.handleDragStart = function (e, type) {
      _this.dragId = e.target.id;
      _this.dragType = type;
      _this.dragX = e.pageX;
      e.dataTransfer.setData("text", _this.dragId);
      e.stopPropagation();
    };

    _this.handleDragOver = function (e) {
      if (_this.dragType === "move" || _this.dragType === "resize" && _this.props.meta.properties[_this.getColumnIndex(_this.dragId)].computedWidth + e.pageX - _this.dragX > 20) {
        e.preventDefault();
      }
    };

    _this.handleDrop = function (e) {
      e.preventDefault();
      var meta = _this.props.meta.properties;

      if (_this.dragType) {
        if (_this.dragType === "move" && !utils.isNullOrUndefined(_this.dragId) && _this.dragId !== e.target.id) {
          meta[_this.getColumnIndex(_this.dragId)].index_ = meta[_this.getColumnIndex(e.target.id)].index_ + 0.1;
          meta.sort(function (a, b) {
            return a.index_ - b.index_;
          });
          computeMetaPositions(_this.props.meta);

          _this.props.onMetaChange();
        } else if (_this.dragType === "resize" && !utils.isNullOrUndefined(_this.dragX) && !utils.isNullOrUndefined(e.pageX)) {
          var column = meta[_this.getColumnIndex(_this.dragId)];

          var zoom = column.computedWidth / column.width;
          column.computedWidth += e.pageX - _this.dragX;
          column.width = column.computedWidth / zoom;
          computeMetaPositions(_this.props.meta);

          _this.props.onMetaChange();
        }
      }

      _this.dragId = null;
      _this.dragType = null;
      _this.dragX = null;
    };

    return _this;
  }

  _createClass(Headers, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      return !this.props.changingFilter;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props$scroll = this.props.scroll,
          shift = _this$props$scroll.shift,
          index = _this$props$scroll.startIndex;
      var _this$props = this.props,
          meta = _this$props.meta,
          width = _this$props.width,
          height = _this$props.height,
          onChange = _this$props.onChange,
          openFilter = _this$props.openFilter,
          headersLength = _this$props.headersLength,
          locked = _this$props.locked,
          auditedRow = _this$props.auditedRow,
          auditStatus = _this$props.auditStatus,
          componentId = _this$props.componentId,
          id = _this$props.id,
          data = _this$props.data,
          params = _this$props.params;
      var cells = [];
      var position = 0,
          first = true;

      if (!locked) {
        index = Math.max(index, utils.isNullOrUndefined(meta.lockedIndex) ? 0 : meta.lockedIndex + 1);
      } else {
        index = 0;
        shift = 0;
      }

      while (index < meta.properties.length && position < width) {
        var column = meta.properties[index];
        var columnWidth = Math.max(Math.min(first ? column.computedWidth + shift : column.computedWidth, width - position), 0);
        var div = null;

        if (!column.hidden && columnWidth) {
          first = false;
          div = header(column, position, height / headersLength, columnWidth, this.handleClick, this.handleDragStart, this.handleDragOver, this.handleDrop, componentId || id);

          if (headersLength > 1) {
            if (auditedRow) {
              div = [div];
              var _style = {
                // position: "absolute",
                // left: position,
                width: columnWidth,
                // top: height / 2,
                height: height / 2
              };
              div.push(auditCell(auditedRow, column, auditStatus, data, params, _style, componentId || id));
            } else {
              div = [div];

              if (!["object", "array", "function", "text"].includes(utils.nullValue(column.dataType, "object"))) {
                //  filter (or filter from0
                div.push(filter(column, position, height / headersLength, columnWidth, false, onChange, openFilter, componentId)); // empty cell
              } else {
                div.push(filterEmpty(column.id, position, columnWidth, height / headersLength));
              } // filter "to" (between)


              if (headersLength === 3) {
                if (column.filterType === "between" && !["object", "array", "function", "text"].includes(utils.nullValue(column.dataType, "object"))) {
                  div.push(filter(column, position, height / headersLength, columnWidth, column.filterType === "between", onChange, openFilter, componentId)); // empty cell
                } else {
                  div.push(filterEmpty("".concat(column.id, "-to"), position, columnWidth, height / headersLength));
                }
              }
            }

            div = React.createElement("div", {
              key: column.id || "undefined ".concat(column.index_),
              style: {
                // position: "absolute", toto
                left: position,
                display: "block",
                width: columnWidth,
                height: height
              }
            }, div);
          }

          cells.push(div);
          position += columnWidth;
        }

        index += 1;
      }

      var style = {
        width: width,
        height: height,
        // overflow: "hidden",
        display: "flex"
      };

      if (!locked) {
        style.overflow = "hidden";
      }

      if (cells.length) {
        return React.createElement("div", {
          id: "tutut",
          key: -2 - locked,
          className: locked ? "zebulon-locked-headers" : "" // id={type + filterTo ? "To" : ""}
          ,
          style: _objectSpread({}, this.props.style, style, {
            position: "relative"
          })
        }, cells);
      } else {
        return null;
      }
    }
  }]);

  return Headers;
}(Component);
export var statusCell = function statusCell(style, className, index, status, _onClick, onDoubleClick, handleErrors, componentId, checkable, checked, _onChange, isAudit, draggable, handleDragStart) {
  var glyph;

  if (status.deleted_) {
    glyph = "X";
  } else if (status.new_) {
    glyph = "+";
  } else if (status.updated_) {
    glyph = "√";
  } else {
    glyph = null;
  }

  var errors = getRowErrors(status, status.index_);

  if (errors.length && !status.deleted_) {
    style.color = "red";
  }

  if (checkable) {
    glyph = React.createElement("input", {
      type: "checkbox",
      checked: checked || false,
      onChange: function onChange() {
        return _onChange(status.rowUpdated.index_);
      } // style={{ height: 20 }}

    });
  }

  var id = "status: ".concat(componentId, "-").concat(index, "-");
  return React.createElement(ContextualMenuClient, {
    id: id,
    key: id,
    index: index,
    className: className,
    style: style,
    onClick: function onClick(e) {
      return _onClick(index, e.shiftKey);
    },
    onMouseOver: function onMouseOver(e) {
      return handleErrors(e, errors);
    },
    onMouseOut: function onMouseOut(e) {
      return handleErrors(e, []);
    },
    onDoubleClick: onDoubleClick ? function (e) {
      return onDoubleClick(e, status.rowUpdated);
    } : function () {},
    draggable: draggable,
    onDragStart: handleDragStart,
    status: status // row={row}
    ,
    menu: "row-header-menu",
    componentId: componentId
  }, glyph);
};
export var Status =
/*#__PURE__*/
function (_Component2) {
  _inherits(Status, _Component2);

  function Status(props) {
    var _this2;

    _classCallCheck(this, Status);

    _this2 = _possibleConstructorReturn(this, _getPrototypeOf(Status).call(this, props)); // this.state = { updatedRows: this.props.updatedRows };

    _this2.onClick = function (index, extension) {
      var _this2$props = _this2.props,
          meta = _this2$props.meta,
          scroll = _this2$props.scroll;
      var columns = (meta.visibleIndexes || [0])[0];
      var startRowIndex = extension ? _this2.props.selectedIndex : index;

      _this2.props.selectRange({
        end: {
          rows: index,
          columns: columns
        },
        start: {
          rows: startRowIndex,
          columns: meta.properties.length - 1
        }
      }, undefined, undefined, undefined, false, index === scroll.startIndex || index === _this2.stopIndex);
    };

    _this2.onChange = function (index) {
      if (_this2.props.checkable) {
        // const updatedRows = this.state.updatedRows;
        var updatedRows = _this2.props.updatedRows; // if (!updatedRows[index]) {
        //   updatedRows[index] = { errors: {} };
        // }

        var checked = !updatedRows[index].rowUpdated.checked_; // updatedRows[index].checked_ = checked;

        updatedRows[index].rowUpdated.checked_ = checked;

        if (_this2.props.checkable === 2) {
          // updatedRows[index + 1 - 2 * (index % 2)].checked_ = !checked;
          updatedRows[index + 1 - 2 * (index % 2)].rowUpdated.checked_ = !checked;
        } // this.setState({ updatedRows });

      }
    };

    _this2.handleDragStart = function (e) {
      e.stopPropagation();
      e.dataTransfer.setData("text", "status: ".concat(e.target.id));
    };

    return _this2;
  } // componentWillReceiveProps(nextProps) {
  //   if (this.state.updatedRows !== nextProps.updatedRows) {
  //     this.setState({ updatedRows: nextProps.updatedRows });
  //   }
  // }


  _createClass(Status, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return !nextProps.status.loadingPage && !nextProps.noUpdate;
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props2 = this.props,
          height = _this$props2.height,
          rowHeight = _this$props2.rowHeight,
          data = _this$props2.data,
          scroll = _this$props2.scroll,
          selectedIndex = _this$props2.selectedIndex,
          handleErrors = _this$props2.handleErrors,
          dataLength = _this$props2.dataLength,
          componentId = _this$props2.componentId,
          checkable = _this$props2.checkable,
          onDoubleClick = _this$props2.onDoubleClick,
          isAudit = _this$props2.isAudit,
          draggable = _this$props2.draggable,
          statusChanged = _this$props2.statusChanged;
      var updatedRows = this.props.updatedRows;
      var index = 0,
          indexPage = 0,
          rows = data;

      if (typeof data === "object" && data.page) {
        rows = data.page;
        indexPage = data.pageStartIndex;
      }

      var cells = [];

      while (index < Math.min(dataLength || data.length, Math.ceil(height / rowHeight))) {
        var style = {
          // position: "relative",
          top: index === 0 ? 0 : scroll.shift + index * rowHeight,
          width: rowHeight,
          height: index === 0 ? rowHeight + scroll.shift : Math.min(rowHeight, height - (scroll.shift + index * rowHeight))
        };

        if (index + scroll.startIndex - indexPage < rows.length) {
          (function () {
            var row = rows[index + scroll.startIndex - indexPage];
            var status_ = getRowStatus(updatedRows, row); //updatedRows[index].checked_updatedRows[row.index_];
            // if (checkable) {
            //   if (row.checked_ !== undefined && updatedRow.checked_ === undefined) {
            //     updatedRow.checked_ = row.checked_;
            //   } else if (
            //     row.checked_ === undefined &&
            //     updatedRow.checked_ !== undefined
            //   ) {
            //     row.checked_ = updatedRow.checked_;
            //   }
            // }

            var className = classnames({
              "zebulon-table-status": true,
              "zebulon-table-status-selected": selectedIndex === index + scroll.startIndex
            });
            var ix = index;
            cells.push(statusCell(style, className, ix + scroll.startIndex, status_, _this3.onClick, onDoubleClick, function (e, errors) {
              return handleErrors(e, ix, errors);
            }, componentId, checkable, row.checked_, _this3.onChange, isAudit, draggable));
          })();
        }

        index += 1;
      }

      this.stopIndex = index + scroll.startIndex - 1;
      return React.createElement("div", {
        key: "status: " + componentId,
        id: "status: " + componentId,
        style: {
          width: rowHeight,
          height: height,
          // overflow: "hidden",
          position: "relative",
          diplay: "flex"
        }
      }, cells);
    }
  }]);

  return Status;
}(Component);