import _objectSpread from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/objectSpread";
import _toConsumableArray from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/toConsumableArray";
import _classCallCheck from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/classCallCheck";
import _createClass from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/getPrototypeOf";
import _inherits from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/inherits";
import _assertThisInitialized from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/assertThisInitialized";
import React, { Component } from "react";
import ReactDOM from "react-dom";
import { ZebulonTableMenu } from "./ZebulonTable.menu";
import { Table } from "./Table";
import { computeMetaPositions } from "./utils/compute.meta";
import { ResizableBox } from "react-resizable";
import "./index.css";
import { utils, ConfirmationModal, accessors, constants, functions, ContextualMenu, EventHandler } from "zebulon-controls";
import { metaFunctions } from "./MetaDescriptions";
import { getFilters, getSorts, computeData, // computeMeta,
computeMetaFromData, getSizes } from "./utils";
import { rollback, rollbackAll, rollbackFiltered, errorHandler, getUpdatedRows } from "./utils/utils";
export var ZebulonTable =
/*#__PURE__*/
function (_ZebulonTableMenu) {
  _inherits(ZebulonTable, _ZebulonTableMenu);

  function ZebulonTable(_props) {
    var _this;

    _classCallCheck(this, ZebulonTable);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ZebulonTable).call(this, _props)); // this.onClose.bind(this);

    _this.setFilters = function (filters, columns) {
      columns.forEach(function (column) {
        if (filters[column.id]) {
          column.filterType = filters[column.id].filterType;
          column.v = filters[column.id].v;
          column.vTo = filters[column.id].vTo;
          column.link = filters[column.id].link;
          filters[column.id] = column;
        } else if (!utils.isNullOrUndefined(column.v) || column.filterType === "between" && !utils.isNullOrUndefined(column.vTo)) {
          filters[column.id] = column;
        }
      });
      return filters;
    };

    _this.setSorts = function (sorts, columns) {
      columns.forEach(function (column) {
        if (sorts[column.id]) {
          column.sortOrder = sorts[column.id].sortOrder;
          column.sort = sorts[column.id].direction;
        } else {
          column.sortOrder = undefined;
          column.sort = undefined;
        }
      });
    };

    _this.refresh = function () {
      return _this.setState(_this.getData(_this.props));
    };

    _this.getData = function (props) {
      if (_this._isMounted) {
        _this.setState({
          status: {
            loaded: false,
            loading: true
          }
        });
      }

      _this.observable = null;
      var data = props.data,
          meta = props.meta,
          params = props.params,
          filteredData = props.filteredData;
      var _this$state = _this.state,
          sorts = _this$state.sorts,
          filters = _this$state.filters;

      if (props.filters) {
        Object.values(props.filters).filter(function (filter) {
          return filter.link;
        }).forEach(function (filter) {
          return filters[filter.id] = filter;
        });
      }

      var message = {
        dataObject: meta.table.object,
        params: params,
        meta: meta,
        filters: getFilters(meta.properties, filters || {}),
        sorts: sorts ? Object.values(sorts) : getSorts(meta.properties),
        props: props,
        state: _this.state
      };

      if (typeof data === "function") {
        data = data(message);
      } else if (!Array.isArray(data) && (meta && props.select || meta.table.select)) {
        data = props.select || _this.state.functions.getAccessorFunction(meta.table.object, "dmls", meta.table.select);
        data = data(message);
      }

      if (Array.isArray(data)) {
        if (meta.table.noDataMutation) {
          data = _toConsumableArray(data);
        }

        _this.initData(data, meta, _this.state.sizes.zoom, _this.state.functions, 0, filters);

        _this.subscribe(message, _this.state.meta.table.subscription);
      } else if (utils.isPromise(data)) {
        _this.resolvePromise(data, message);
      } else if (utils.isObservable(data)) {
        _this.subscribeObservable(data, message);

        data = [];
      } else {
        data = [];
      } // }


      return {
        data: data,
        meta: meta,
        filters: filters,
        sorts: sorts,
        updatedRows: {}
      };
    };

    _this.initData = function (data, meta, zoom, functions, startIndex, filters) {
      if (Array.isArray(data)) {
        meta.config = _this.config ? _this.config.properties : undefined;
        computeMetaFromData(data, meta, zoom, functions, _this.props.privileges ? _this.props.privileges.get(_this.props.componentName) : null);
        _this.config = undefined;
        Promise.all(meta.promises).then(function (values) {
          _this.initData2(data, meta, zoom, functions, startIndex, filters);
        });
      }
    };

    _this.initData2 = function (data_, meta, zoom, functions, startIndex) {
      // !! filters may have change after getData call
      var filters = _this.state.filters;

      if (Array.isArray(data_)) {
        var data = meta.table.noDataMutation ? _toConsumableArray(data_) : data_;
        computeData(data, meta, startIndex, meta.table.noDataMutation);

        if (_this.props.filteredData && meta.indexPk) {
          var updatedRows = _this.state.updatedRows;
          Object.values(_this.props.filteredData).forEach(function (data) {
            return updatedRows[meta.indexPk[data.id]] = data;
          });
        }

        if (_this.props.onGetData) {
          _this.props.onGetData({
            data: data,
            meta: meta,
            updatedRows: _this.state.updatedRows
          });
        }

        _this.initSizes(meta, data, _this.state.sizes);

        if (filters && meta.properties.length !== 0) {
          _this.setFilters(filters, meta.properties);
        } // sorts are applied only the first time


        if (_this.state.sorts && meta.properties.length !== 0) {
          _this.setSorts(_this.state.sorts, meta.properties); // this.sorts = null;

        }

        if (_this._isMounted) {
          _this.setState({
            data: data,
            status: {
              loaded: true,
              loading: false
            },
            filters: filters
          });
        } else {
          _this.state.data = data;
          _this.state.filters = filters;
          _this.state.status = {
            loaded: true,
            loading: false
          };
        }
      }
    };

    _this.resolvePromise = function (data, message) {
      data.then(function (data) {
        var _this$state2 = _this.state,
            meta = _this$state2.meta,
            functions = _this$state2.functions,
            sizes = _this$state2.sizes;

        _this.initData(data, meta, sizes.zoom, functions, 0, message.filters);

        _this.subscribe(message, meta.table.subscription);

        return data;
      }).catch(function (error) {
        return _this.setState({
          data: [],
          status: {
            loaded: false,
            loading: false,
            error: error
          }
        });
      });
    };

    _this.subscribeObservable = function (observable, message) {
      _this.observable = observable;

      _this.observable.subscribe(function (x) {
        _this.initData(x, _this.state.meta, _this.state.sizes.zoom, _this.state.functions, _this.state.data.length, _this.state.filters);

        if (_this.observable) {
          _this.setState({
            data: _this.state.data.concat(x),
            meta: _this.state.meta
          });
        }
      }, function (e) {
        return _this.setState({
          data: [],
          status: {
            loaded: false,
            loading: false,
            error: e
          }
        });
      }, function () {
        _this.setState({
          status: {
            loaded: true,
            loading: false
          }
        });

        _this.subscribe(message, _this.state.meta.table.subscription);
      });
    };

    _this.subscribe = function (message, subscription) {
      if (subscription) {
        var _this$state3 = _this.state,
            data = _this$state3.data,
            meta = _this$state3.meta,
            updatedRows = _this$state3.updatedRows;
        message.index = meta.indexRowId || meta.indexPk;
        message.data = data;
        message.updatedRows = updatedRows;
        _this.observable = subscription.observableFunction(message);
        var _subscription$observe = subscription.observerFunctions,
            onNext = _subscription$observe.onNext,
            onError = _subscription$observe.onError,
            onCompleted = _subscription$observe.onCompleted;

        var onNextFunction = function onNextFunction(data) {
          onNext(data, message);

          _this.setState({
            status: {
              loaded: true,
              loading: false
            }
          });
        };

        var onErrorFunction = function onErrorFunction(error) {
          onError(error, message);

          _this.setState({
            status: {
              loaded: false,
              loading: false,
              error: error
            }
          });
        };

        _this.observable.subscribe(onNextFunction, onErrorFunction, function () {
          return onCompleted(message);
        });
      }
    };

    _this.initSizes = function (meta, data, sizes) {
      if (sizes.auto) {
        sizes.height = null;
        sizes.width = null;
      }

      if (!sizes.height || !sizes.width) {
        var tableSizes = getSizes(meta, sizes.rowHeight || meta.row.height || 25);

        if (!sizes.height && data) {
          sizes.height = meta.table.height || Math.min(sizes.maxHeight || 1000, Math.max(sizes.minHeight || 100, tableSizes.headersHeight + data.length * tableSizes.rowHeight));
        }

        if (!sizes.width) {
          var scrollbarSize = tableSizes.headersHeight + data.length * tableSizes.rowHeight > (sizes.maxHeight || 1000) ? constants.ScrollbarSize : 0;
          sizes.width = meta.row.width || Math.min(sizes.maxWidth || 2000, Math.max(sizes.minWidth || 100, tableSizes.headersWidth + tableSizes.rowWidth + scrollbarSize));
        }
      }
    };

    _this.componentDidMount = function () {
      _this._isMounted = true;

      if (_this.props.getComponent) {
        _this.props.getComponent(_assertThisInitialized(_assertThisInitialized(_this)));
      }
    };

    _this.componentWillUnmount = function () {
      return _this._isMounted = false;
    };

    _this.handleKeyEvent = function (e) {
      if (_this.state.confirmationModal && _this.modal) {
        if ((e.which || e.keyCode) === 27) {
          // escape
          e.preventDefault();

          _this.modal.onEscape();
        }

        if ((e.which || e.keyCode) === 13) {
          // enter
          e.preventDefault();

          _this.modal.onEnter();
        } else if (_this.modal.component && _this.modal.component.handleKeyDown) {
          _this.modal.component.handleKeyDown(e);
        }

        return;
      }

      var zoom = utils.isZoom(e);

      if (zoom && (_this.props.isActive === undefined || _this.props.isActive)) {
        e.preventDefault();
        var sizes = _this.state.sizes;
        sizes.zoom *= zoom === 1 ? 1.1 : 1 / 1.1;
        computeMetaPositions(_this.state.meta, sizes.zoom);

        _this.setState({
          sizes: _objectSpread({}, sizes)
        });

        return;
      }

      if (!_this.table) {
        return;
      } else if (e.type === "copy") {
        _this.handleCopy(e);
      } else if (e.type === "paste") {
        _this.handlePaste(e);
      } else if (e.type === "keydown") {
        _this.handleKeyDown(e);
      }
    };

    _this.handleKeyDown = function (e) {
      if (!e.defaultPrevented && _this.table && _this.table.handleKeyDown && (_this.props.isActive === undefined || _this.props.isActive)) {
        _this.table.handleKeyDown(e);
      }
    };

    _this.handleCopy = function (e) {
      if (!e.defaultPrevented && _this.table && _this.table.handleCopy && (_this.props.isActive === undefined || _this.props.isActive)) {
        // e.preventDefault();
        _this.table.handleCopy(e);
      }
    };

    _this.handlePaste = function (e) {
      if (!e.defaultPrevented && _this.table && _this.table.handlePaste && (_this.props.isActive === undefined || _this.props.isActive)) {
        // e.preventDefault();
        _this.table.handlePaste(e);
      }
    };

    _this.rollback = function (updatedRows, index) {
      rollback(updatedRows, index);

      if (_this.props.linkedObjects) {
        _this.props.linkedObjects.forEach(function (object) {
          return object.rollbackFiltered();
        });
      }
    };

    _this.rollbackFiltered = function () {
      rollbackFiltered(_this.state.updatedRows, _this.props.filters);

      _this.setState({
        status: _this.state.status
      });
    };

    _this.errorHandler = function (message, action, callback, callbackReDo) {
      var handler = (_this.props.errorHandler || errorHandler)[action];

      if (action === "onTableQuit" && !(message.updatedRows || {}).nErrors || action === "onSave" && !(message.updatedRows || {}).nErrorsServer && !message.conflicts) {
        handler = null;
      } else if (action === "onRowQuit" && !((message.status || {}).errors || {}).n_) {
        handler = null;
      }

      if (handler) {
        var ok = handler(message);
        var body = message.modalBody;
        message.modalBody = null;
        var conflicts = message.conflicts;
        message.conflicts = null;

        if (ok === false) {
          if (body) {
            _this.setState({
              confirmationModal: true,
              modal: {
                body: body,
                type: "Ok"
              }
            });
          }

          return false;
        } else if (body) {
          var type = action === "onTableChange" ? "YesNoCancel" : "YesNo";

          _this.setState({
            confirmationModal: true,
            modal: {
              body: body,
              type: type,
              callback: callback
            }
          });

          return;
        } else if (conflicts) {
          var resolveConflicts = function resolveConflicts(updatedRows) {
            return function (ok, data) {
              if (ok) {
                // back to server version
                data.forEach(function (index) {
                  var row = conflicts.data[index].server;
                  row.index_ = index;
                  updatedRows[index].row = row;

                  _this.rollback(updatedRows, index);
                });
                (action === "onSave" && callbackReDo ? callbackReDo : callback)(ok);
              }
            };
          };

          var index = message.messages.findIndex(function (msg) {
            return msg.meta.table.object === conflicts.object;
          });
          var zebulonTable = message.meta.table.object === conflicts.object ? _assertThisInitialized(_assertThisInitialized(_this)) : _this.props.linkedObjects.find(function (object) {
            return object.state.meta.table.object === conflicts.object;
          }); // zebulonTable.confirmationModal = true;

          zebulonTable.setState({
            confirmationModal: true,
            modal: {
              body: zebulonTable.onConflict(conflicts.data),
              type: "conflict",
              callback: resolveConflicts(message.messages[index].updatedRows)
            }
          });
          return;
        }
      }

      return true;
    };

    _this.onClose = function (callback_) {
      return _this.onTableChange("close", callback_);
    };

    _this.onTableChange = function (type, callback_) {
      var ok = _this.table.canQuit("rowQuit", function (ok) {
        if (ok) {
          _this.onTableChange_(type, callback_);
        }
      });

      if (ok) {
        _this.onTableChange_(type, callback_);
      }
    };

    _this.rollbackAll = function () {
      rollbackAll(_this.state.updatedRows, _this.state.data);

      _this.setState({
        updatedRows: {}
      });

      if (_this.table) {
        _this.table.updated = false;
        _this.table.rowUpdated = false;
        _this.table.tableUpdated = false;

        _this.table.adjustScrollRows(_this.table.state.filteredData);
      }

      if (_this.props.linkedObjects) {
        _this.props.linkedObjects.forEach(function (object) {
          if (object.rollbackAll) {
            object.rollbackAll();
          }
        });
      }
    };

    _this.onTableChange_ = function (type, callback_) {
      var callback = !callback_ && type === "refresh" ? function (ok) {
        if (ok) {
          _this.getData(_this.props);

          _this.table.updated = false;
          _this.table.rowUpdated = false;
          _this.table.tableUpdated = false;

          if (_this.props.linkedObjects) {
            _this.props.linkedObjects.forEach(function (object) {
              if (object.refresh) {
                object.refresh();
              }
            });
          }
        }
      } : callback_;

      if (!getUpdatedRows(_this.state.updatedRows).length) {
        return callback(true);
      }

      var message = {
        updatedRows: _this.state.updatedRows,
        meta: _this.state.meta,
        data: _this.state.data,
        params: _this.props.params,
        type: type
      };

      var save = function save(carryOn, ok) {
        if (carryOn && ok) {
          _this.onSave(callback);
        } else if (carryOn) {
          _this.rollbackAll();

          callback(true);
        } else {
          callback(false);
        }
      };

      var ok = _this.errorHandler(message, "onTableChange", save);

      if (ok !== undefined) {
        callback(ok);
      }
    };

    _this.onSave = function (callback) {
      var message = {
        messages: [{
          updatedRows: _this.state.updatedRows,
          // linkedUpdatedRows: this.props.linkedUpdatedRows,
          meta: _this.state.meta,
          data: _this.state.data,
          params: _this.props.params,
          table: _this.table
        }],
        updatedRows: _this.state.updatedRows,
        meta: _this.state.meta,
        data: _this.state.data,
        params: _this.props.params,
        table: _this.table
      };

      if (_this.props.linkedObjects) {
        _this.props.linkedObjects.forEach(function (object) {
          var _object$state = object.state,
              meta = _object$state.meta,
              data = _object$state.data;

          if (meta && meta.table.object && (meta.table.onSaveFunction || _this.props.onSave)) {
            message.messages.push({
              updatedRows: object.state.updatedRows,
              meta: meta,
              data: data,
              params: _this.props.params,
              table: object.table
            });
          }
        });
      }

      if (_this.onSave_(message, callback)) {
        return true;
      }

      return false;
    };

    _this.onSave_ = function (message, callback) {
      // in layouts save can be done without "data" as  data to update may be not anymore in the grid
      // in this case, refresh is required as we can't recompute data
      var end = function end(ok_) {
        if (ok_) {
          message.messages.forEach(function (message) {
            var data = message.data,
                meta = message.meta,
                serverData = message.serverData,
                updatedRows = message.updatedRows;
            var deleteds = []; // deleteds new rows are not sent to the server

            Object.keys(message.updatedRows).filter(function (key) {
              return !Number.isNaN(Number(key)) && message.updatedRows[key].new_ && message.updatedRows[key].deleted_;
            }).forEach(function (key) {
              return deleteds.push(message.updatedRows[key].rowUpdated.index_);
            }); // retrieve changes made on server

            if (serverData) {
              serverData.forEach(function (row) {
                if (row.status_ === "deleted") {
                  deleteds.push(row.index_);

                  if (!data) {
                    updatedRows[row.index_].hidden_ = true;
                  }
                } else {
                  delete row.status_;
                  var rowUpdated = updatedRows[row.index_].rowUpdated;
                  Object.keys(row).forEach(function (key) {
                    return rowUpdated[key] = row[key];
                  });
                }
              });
            } else {
              Object.values(message.updatedRows).filter(function (status) {
                return status.deleted_;
              }).forEach(function (status, index) {
                deleteds.push(status.rowUpdated.index_);
              });
            }

            if (deleteds.length && data) {
              deleteds.sort(function (x, y) {
                return (x > y) - (y > x);
              });
              deleteds.forEach(function (index_, index) {
                return data.splice(index_ - index, 1);
              });
            } // a voir startIndex en mode pagination
            // this.setState({ updatedRows: {} });


            Object.keys(message.updatedRows).forEach(function (key) {
              return delete message.updatedRows[key];
            });

            if (message.table) {
              var filteredData = message.table.state.filteredData;

              if (deleteds.length) {
                deleteds.forEach(function (index_) {
                  var index = filteredData.findIndex(function (row) {
                    return row.index_ === index_;
                  });

                  if (index !== -1) {
                    filteredData.splice(index, 1);
                  }
                });
                message.table.adjustScrollRows(filteredData);
                message.table.updated = false;
                message.table.rowUpdated = false;
                message.table.tableUpdated = false;
              }

              message.table.setState({
                filteredDataLength: filteredData.length
              });
            }

            if (data) {
              computeData(data, meta, 0);
            }
          });
        }

        if (_this.props.onSaveOk) {
          _this.props.onSaveOk(message);
        }

        if (callback) {
          callback(ok_);
        }
      };

      var errorAfter = function errorAfter(ok_) {
        var ok = ok_ && _this.errorHandler(message, "onSaveAfter", end);

        if (ok !== undefined) {
          end(ok);
        }
      };

      var saveAfter = function saveAfter(ok_) {
        var onSaveAfter = _this.props.onSaveAfter || _this.state.meta.table.onSaveAfterFunction || function () {
          return true;
        };

        var ok = ok_ && onSaveAfter(message, errorAfter);

        if (ok !== undefined) {
          errorAfter(ok);
        }
      };

      var errorSave = function errorSave(ok_) {
        var ok = ok_ && _this.errorHandler(message, "onSave", saveAfter, saveBefore);

        if (ok !== undefined) {
          saveAfter(ok);
        }
      };

      var save = function save(ok_) {
        var onSave = _this.props.onSave || _this.state.meta.table.onSaveFunction || function () {
          return true;
        };

        var ok = ok_ && onSave(message, errorSave);

        if (ok !== undefined) {
          errorSave(ok);
        }
      };

      var errorBefore = function errorBefore(ok_) {
        var ok = ok_ && _this.errorHandler(message, "onSaveBefore", save);

        if (ok !== undefined) {
          save(ok);
        }
      };

      var saveBefore = function saveBefore(ok_) {
        var updatedRows = message.updatedRows;

        if (!getUpdatedRows(updatedRows).length) {
          return end(true);
        }

        var onSaveBefore = _this.props.onSaveBefore || _this.state.meta.table.onSaveBeforeFunction || function () {
          return true;
        };

        var ok = ok_ && onSaveBefore(message, errorBefore);

        if (ok !== undefined) {
          errorBefore(ok);
        }
      };

      var canQuit = function canQuit(ok_) {
        var ok = ok_ && _this.table.canQuit("rowQuit", saveBefore);

        if (ok !== undefined) {
          saveBefore(ok);
        }
      };

      canQuit(true);
    };

    _this.onConfirm = function (button, type) {
      _this.setState({
        modalCancel: false,
        modal: null,
        confirmationModal: false
      }); // this.confirmationModal = false;

    };

    _this.onForeignKey = function (ForeignObject, filters, selection, callback) {
      var _this$state$sizes = _this.state.sizes,
          rowHeight = _this$state$sizes.rowHeight,
          zoom = _this$state$sizes.zoom,
          height = _this$state$sizes.height,
          width = _this$state$sizes.width;
      var body = React.createElement(ForeignObject, {
        sizes: {
          minHeight: 200,
          maxHeight: height,
          minWidth: 300,
          maxWidth: width,
          rowHeight: rowHeight * zoom
        },
        filters: filters,
        functions: _this.props.functions
      }); // this.confirmationModal = true;

      var state = _this.state;
      state.confirmationModal = true;
      state.modal = {
        body: body,
        type: "foreignKey",
        selection: selection,
        callback: callback
      };

      _this.setState({
        confirmationModal: true,
        modal: {
          body: body,
          type: "foreignKey",
          selection: selection,
          callback: callback
        }
      });
    };

    _this.onConflict = function (conflicts) {
      var properties = [{
        id: "From",
        width: 55
      }];

      _this.state.meta.properties.forEach(function (property) {
        return properties.push(_objectSpread({}, property));
      });

      var meta = _objectSpread({}, _this.state.meta, {
        indexPk: {},
        table: _objectSpread({}, _this.state.meta.table, {
          editable: false,
          checkable: 2,
          select: undefined,
          subscription: undefined,
          noFilter: true,
          caption: "Conflicts resolution."
        }),
        properties: properties
      });

      var data = [];
      var index = 0,
          updatedRows = {};
      Object.keys(conflicts).forEach(function (index_) {
        var conflict = conflicts[index_];
        conflict.server.From = conflict.server.deleted_ ? React.createElement("div", {
          style: {
            color: "red"
          }
        }, "Server") : "Server";
        updatedRows[index] = {
          checked_: true,
          index_: index_
        };
        var ix = index;
        conflict.server.index_ = ix;
        data.push(conflict.server);
        updatedRows[index + 1] = {
          checked_: false
        };
        data.push(_objectSpread({}, conflict.client, {
          From: conflict.client.deleted_ ? React.createElement("div", {
            style: {
              color: "red"
            }
          }, "Client") : "Client",
          index_: ix + 1
        }));
        index += 2;
      });
      var _this$state$sizes2 = _this.state.sizes,
          rowHeight = _this$state$sizes2.rowHeight,
          zoom = _this$state$sizes2.zoom,
          height = _this$state$sizes2.height,
          width = _this$state$sizes2.width;
      return React.createElement(ZebulonTable, {
        sizes: {
          minHeight: 200,
          maxHeight: height,
          minWidth: 300,
          maxWidth: width,
          rowHeight: rowHeight * zoom
        },
        meta: meta,
        data: data,
        isModal: true,
        functions: _this.state.functions,
        updatedRows: updatedRows
      });
    };

    _this.onResize = function (e, data) {
      _this.setState({
        sizes: _objectSpread({}, _this.state.sizes, {
          height: data.size.height,
          width: data.size.width
        })
      });
    };

    _this.getConfiguration = function () {
      return {
        sizes: _objectSpread({}, _this.state.sizes, {
          auto: false,
          minHeight: null,
          maxHeight: null,
          minWidth: null,
          maxWidth: null
        }),
        properties: _this.state.meta.properties.reduce(function (acc, property) {
          acc[property.id] = {
            index_: property.index_,
            width: property.width,
            locked: property.locked
          };
          return acc;
        }, {})
      };
    };

    _this.state = {
      meta: _props.meta,
      updatedRows: _props.updatedRows || {},
      sizes: _props.sizes || {
        auto: true
      },
      keyEvent: _props.keyEvent,
      confirmationModal: false,
      params: _props.params || {},
      sorts: _props.sorts || {},
      filters: _props.filters || {},
      status: {
        loaded: false,
        loading: true
      }
    };
    _this.state.sizes.zoom = _this.state.sizes.zoom || 1;
    _this.state.sizes.rowHeight = _this.state.sizes.rowHeight || 25;
    _this.state.functions = _props.functions || functions.functions([]);

    _this.state.functions.mergeFunctionsObjects([accessors, metaFunctions]); // this.sorts = this.state.sorts;


    _this.config = _props.config;

    if (_this.config && _this.config.sizes) {
      _this.state.sizes = _objectSpread({}, _this.state.sizes, _this.config.sizes);
    }

    _this.state.data = _props.data;

    _this.getData(_props);

    _this.saveConfirmationAnswer = function (ok) {
      return ok;
    };

    return _this;
  }

  _createClass(ZebulonTable, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      var data = nextProps.data,
          meta = nextProps.meta,
          sizes = nextProps.sizes,
          keyEvent = nextProps.keyEvent,
          updatedRows = nextProps.updatedRows,
          filters = nextProps.filters,
          status = nextProps.status,
          closeRequired = nextProps.closeRequired,
          refresh = nextProps.refresh,
          config = nextProps.config;

      if (config !== this.props.config) {
        this.config = config;
      }

      if (updatedRows && this.props.updatedRows !== updatedRows) {
        this.setState({
          updatedRows: updatedRows
        });
      }

      if (this.props.data !== data || this.props.status !== status && status.loaded || this.props.filters !== filters && meta.table.filteredByServer || this.props.refresh !== refresh && refresh !== undefined) {
        var ok = true; // if (!closeRequired && !this.props.closeRequired) {

        ok = this.onTableChange("refresh", function (ok) {
          if (ok) {
            // this.sorts = this.state.sorts;
            if (_this2.props.filters !== filters && meta.table.filteredByServer) {
              var state = _this2.state;
              state.filters = filters;
            }

            _this2.getData(nextProps);

            if (_this2.props.linkedObjects) {
              _this2.props.linkedObjects.forEach(function (object) {
                return object.refresh();
              });
            }
          }
        }); // }

        if (ok) {
          this.getData(nextProps);
        }
      } else {
        if (this.props.sizes !== sizes) {
          this.setState({
            sizes: sizes
          });
        }
      }

      if (this.props.filters !== filters) {
        this.setState({
          filters: filters
        });
      } // }


      if (nextProps.auditedRow && nextProps.auditedRow !== this.state.auditedRow) {
        this.setState({
          auditedRow: nextProps.auditedRow,
          audits: undefined
        });

        if (nextProps.auditedRow) {
          var audits = this.state.meta.row.auditFunction({
            row: nextProps.auditedRow,
            type: 2,
            filters: nextProps.filters
          });

          if (utils.isPromise(audits)) {
            this.setState({
              status: {
                loaded: false,
                loading: true
              }
            });
            audits.then(function (audits) {
              _this2.setState({
                auditedRow: nextProps.auditedRow,
                audits: audits || [],
                status: {
                  loaded: true,
                  loading: false
                }
              });
            });
          } else {
            this.setState({
              auditedRow: nextProps.auditedRow,
              audits: audits || []
            });
          }
        }
      } // if (closeRequired && !this.props.closeRequired) {
      //   this.onClose(closeRequired);
      // }

    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var style = {
        fontSize: "".concat((this.props.isModal ? 1 : this.state.sizes.zoom) * 100, "%"),
        position: "relative",
        height: "fitContent"
      };
      var _this$state4 = this.state,
          data = _this$state4.data,
          meta = _this$state4.meta,
          filters = _this$state4.filters,
          updatedRows = _this$state4.updatedRows,
          sizes = _this$state4.sizes,
          status = _this$state4.status,
          auditedRow = _this$state4.auditedRow,
          audits = _this$state4.audits;

      if (auditedRow && audits) {
        meta = _objectSpread({}, meta, {
          table: _objectSpread({}, meta.table, {
            editable: false,
            noOrder: true,
            actions: [],
            caption: "".concat(meta.table.caption || meta.table.object, " (audit :").concat(meta.row.descriptorFunction ? meta.row.descriptorFunction({
              row: auditedRow
            }) : auditedRow.index_, ")")
          })
        }); // linked object

        data = audits;
        filters = {};
        updatedRows = {};

        if (this.props.auditedRow) {
          meta.table.caption = "".concat(meta.table.caption || meta.table.object);
        } else {
          meta.properties = [{
            id: "user_",
            caption: "User",
            width: 80
          }, {
            id: "timestamp_",
            caption: "Time",
            dataType: "number",
            format: "time",
            formatFunction: function formatFunction(_ref) {
              var value = _ref.value;
              return utils.formatValue(new Date(value / 1000000), "dd/mm/yyyy hh:mi:ss");
            },
            width: 150,
            sort: "desc"
          }, {
            id: "status_",
            caption: "Status",
            dataType: "string",
            width: 70,
            locked: true
          }].concat(_toConsumableArray(meta.properties.map(function (property) {
            return _objectSpread({}, property, {
              locked: false,
              v: undefined
            });
          })));
          computeMetaPositions(meta, this.state.sizes.zoom);
          meta.lockedIndex = 2;
          meta.lockedWidth = 300 * this.state.sizes.zoom;
          var rowAudited = updatedRows[auditedRow.index_];

          if (rowAudited && (rowAudited.deleted_ || rowAudited.updated_ || rowAudited.new_) && !(rowAudited.deleted_ && rowAudited.new_)) {
            rowAudited = _objectSpread({}, rowAudited.rowUpdated, {
              status_: rowAudited.deleted_ ? "deleted" : rowAudited.new_ ? "inserted" : "updated"
            });
            data = [rowAudited].concat(data);
          }
        }

        sizes = _objectSpread({}, sizes);
        this.initSizes(meta, data, sizes);
      }

      var componentId = this.props.componentId || "zebulon-table-".concat(this.props.id); // const modal = null;

      var div = React.createElement(EventHandler, {
        id: componentId,
        component: this,
        style: style,
        className: "zebulon-table",
        componentId: componentId
      }, React.createElement(ContextualMenu, {
        key: "table-menu",
        getMenu: this.getMenu,
        componentId: componentId,
        id: "table-menu",
        ref: function ref(_ref2) {
          return _this3.contextualMenu = _ref2;
        }
      }), React.createElement(Table, {
        id: this.props.id,
        componentId: componentId,
        style: this.props.style,
        status: status,
        data: data,
        meta: meta,
        params: this.props.params,
        filters: filters,
        updatedRows: updatedRows,
        key: this.props.id,
        visible: this.props.visible === undefined ? true : this.props.visible // sizes={this.state.sizes}
        ,
        width: sizes.width,
        height: sizes.height,
        zoom: sizes.zoom,
        rowHeight: (this.state.sizes.rowHeight || 25) * (this.state.sizes.zoom || 1),
        caption: this.props.caption,
        isActive: this.props.isActive,
        onActivation: this.props.onActivation,
        ref: function ref(_ref3) {
          return _this3.table = _ref3;
        },
        getActions: this.props.getActions,
        onChange: this.props.onChange,
        onDoubleClick: this.props.onDoubleClick,
        onCellEnter: this.props.onCellEnter,
        onCellQuit: this.props.onCellQuit,
        onRowNew: this.props.onRowNew,
        onRowDelete: this.props.onRowDelete,
        onRowEnter: this.props.onRowEnter,
        onRowQuit: this.props.onRowQuit,
        onTableEnter: this.props.onTableEnter,
        onTableChange: this.onTableChange,
        onTableQuit: this.props.onTableQuit,
        onTableClose: this.props.onTableClose,
        onFilter: this.props.onFilter,
        onSort: this.props.onSort,
        select: this.props.select,
        onGetData: this.props.onGetData,
        onGetPage: this.props.onGetPage,
        onSave: this.onSave,
        onAction: this.props.onAction,
        callbacks: this.props.callbacks,
        errorHandler: this.errorHandler,
        navigationKeyHandler: this.props.navigationKeyHandler,
        contextualMenu: this.contextualMenu // {this.props.contextualMenu}
        ,
        callbackForeignKey: this.props.callbackForeignKey,
        onForeignKey: this.onForeignKey,
        isModal: this.props.isModal,
        modal: this.state.confirmationModal || this.state.modalCancel,
        selection: this.props.selection
      }));

      if (this.props.resizable || this.props.resizable === undefined) {
        div = React.createElement(ResizableBox, {
          width: sizes.width || 100,
          height: sizes.height || 30,
          onResize: this.onResize
        }, div);
      }

      console.log("render zt", meta.table, this.state.modal);
      return (// confirmation modal must be outside of previous elements
        // else it doesnt render in some cases???
        React.createElement("div", null, div, React.createElement(ConfirmationModal, {
          show: this.state.confirmationModal,
          detail: this.state.modal,
          onConfirm: this.onConfirm,
          ref: function ref(_ref4) {
            return _this3.modal = _ref4;
          },
          id: "modal-".concat(this.props.id),
          key: "modal-".concat(this.props.id)
        }))
      );
    }
  }]);

  return ZebulonTable;
}(ZebulonTableMenu);

ZebulonTable.prototype["getState"] = function () {
  return this.state;
};