import _objectSpread from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/objectSpread";
import _classCallCheck from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/classCallCheck";
import _possibleConstructorReturn from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/getPrototypeOf";
import _inherits from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/inherits";
import { Component } from "react";
import { utils } from "zebulon-controls";
import { computeMetaPositions } from "./utils/compute.meta"; // import { rollback } from "./utils/utils";

export var ZebulonTableMenu =
/*#__PURE__*/
function (_Component) {
  _inherits(ZebulonTableMenu, _Component);

  function ZebulonTableMenu() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ZebulonTableMenu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ZebulonTableMenu)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.handleAudit = function (props, item) {
      var status = props.status; // console.log("zebtable", this.state);

      var row = status.row || status.rowUpdated;

      var audits = _this.state.meta.row.auditFunction({
        row: row
      });

      if (utils.isPromise(audits)) {
        _this.setState({
          status: {
            loaded: false,
            loading: true
          }
        });

        audits.then(function (audits) {
          _this.setState({
            auditedRow: row,
            audits: audits || [],
            status: {
              loaded: true,
              loading: false
            }
          });

          if (_this.props.onRowEnter) {
            _this.props.onRowEnter({
              audited: true,
              row: (audits || [])[0]
            });
          }
        });
      } else {
        _this.setState({
          auditedRow: row,
          audits: audits || [],
          status: {
            loaded: true,
            loading: false
          }
        });

        if (_this.props.onRowEnter) {
          _this.props.onRowEnter({
            audited: true,
            row: (audits || [])[0]
          });
        }
      }

      _this.table.handleClickMenu(props, item);
    };

    _this.handleCloseAudit = function (props, item) {
      _this.setState({
        auditedRow: undefined,
        audits: undefined
      });

      if (_this.props.linkedObjects) {
        _this.props.linkedObjects.forEach(function (object) {
          return object.setState({
            auditedRow: undefined,
            audits: undefined
          });
        });
      }

      _this.table.handleClickMenu(props, item);
    };

    _this.handleRollback = function (props, item) {
      _this.rollback(_this.state.updatedRows, props.row.index_);

      _this.table.handleClickMenu(props, item);
    };

    _this.getCustomMenu = function (menu, menus) {
      if (_this.props.contextualMenu && _this.props.contextualMenu[menu]) {
        _this.props.contextualMenu[menu].forEach(function (menu, index) {
          var id = menu.id || 1000000 + menus.length;
          var children = menu.children || (menu.type === "sub-menu" ? [] : undefined);

          var item = _objectSpread({}, menu, {
            id: menu.id || 1000000 + menus.length,
            children: children
          });

          item.onClick = function (e) {
            return (menu.onClick || _this.handleClickMenu)(e, item);
          };

          menus.push(item);
        });
      }
    };

    _this.getMenu = function (menu, data) {
      // console.log(this.state, this.table.state);
      var menus = [];

      if (!_this.props.isActive && _this.props.onActivation) {
        _this.props.onActivation(_this.props.componentId || "zebulon-table-".concat(_this.props.id));
      }

      if (menu === "row-header-menu") {
        if (_this.state.meta.table.editable) {
          menus.push({
            id: menus.length,
            type: "menu-item",
            disable: !(data.status || {}).updated_,
            separation: false,
            caption: "Rollback row updates",
            onClick: _this.handleRollback
          });
        }

        if (_this.state.meta.row.audit) {
          menus.push({
            id: menus.length,
            type: "menu-item",
            disable: _this.state.auditedRow !== undefined,
            // separation: false,
            caption: "Audit",
            onClick: _this.handleAudit
          });
        }
      } else if (menu === "column-header-menu") {
        menus.push({
          id: menus.length,
          type: "menu-item",
          disable: utils.isNullOrUndefined(_this.table.state.meta.lockedIndex),
          separation: false,
          caption: "Unlock columns",
          onClick: _this.table.handleClickMenu
        });
        menus.push({
          id: menus.length,
          type: "menu-item",
          separation: false,
          caption: "Lock columns until ".concat(data.column.caption),
          onClick: _this.table.handleClickMenu
        });
      } else if (menu === "top-left-corner-menu") {
        if (_this.state.meta.table.editable) {
          menus.push({
            id: menus.length,
            type: "menu-item",
            checked: _this.table.state.filters.status_ === undefined,
            caption: "No status filter",
            onClick: _this.table.handleClickMenu
          });

          var checked = function checked(i) {
            return (i | (_this.table.state.filters.status_ || {
              v: 0
            }).v) === (_this.table.state.filters.status_ || {
              v: 0
            }).v;
          };

          menus.push({
            id: menus.length,
            type: "sub-menu",
            separation: menus.length > 0,
            caption: "Status filters",
            children: [{
              id: 101,
              type: "menu-item",
              checked: checked(1),
              separation: false,
              caption: "Updated rows",
              onClick: _this.table.handleClickMenu
            }, {
              id: 102,
              type: "menu-item",
              checked: checked(2),
              separation: false,
              caption: "New rows",
              onClick: _this.table.handleClickMenu
            }, {
              id: 104,
              type: "menu-item",
              checked: checked(4),
              separation: false,
              caption: "Deleted rows",
              onClick: _this.table.handleClickMenu
            }, {
              id: 108,
              type: "menu-item",
              // disable: utils.isNullOrUndefined(this.state.meta.lockedIndex),
              checked: checked(8),
              separation: false,
              caption: "Rows with errors",
              onClick: _this.table.handleClickMenu
            }]
          });
        }

        if (_this.state.meta.row.audit) {
          menus.push({
            id: menus.length,
            type: "menu-item",
            disable: _this.state.auditedRow === undefined,
            separation: _this.state.meta.table.editable,
            caption: "Close audit",
            onClick: _this.handleCloseAudit
          });
        }
      }

      _this.getCustomMenu(menu, menus);

      if (menus.length) {
        return {
          type: "menu",
          position: "bottom",
          children: menus
        };
      } else {
        return null;
      }
    };

    return _this;
  }

  return ZebulonTableMenu;
}(Component);