import _toConsumableArray from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/toConsumableArray";
import _objectSpread from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/objectSpread";
import _classCallCheck from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/classCallCheck";
import _createClass from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/getPrototypeOf";
import _inherits from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/inherits";
import _assertThisInitialized from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/assertThisInitialized";
import React, { Component } from "react";
import cx from "classnames";
import { utils, accessors } from "zebulon-controls";
import { ZebulonTable } from "./ZebulonTable";
import { metaDescriptions, metaFunctions, setPropertyAccessors } from "./MetaDescriptions";
import { computeMeta, computeMetaFromData, getUpdatedRows, computeData, getRowStatus, computeAnalytic } from "./utils";
export var ZebulonTableAndConfiguration =
/*#__PURE__*/
function (_Component) {
  _inherits(ZebulonTableAndConfiguration, _Component);

  function ZebulonTableAndConfiguration(_props) {
    var _this;

    _classCallCheck(this, ZebulonTableAndConfiguration);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ZebulonTableAndConfiguration).call(this, _props));

    _this.initTabsState = function (state, props, constructor) {
      if (props.tabs) {
        props.tabs.forEach(function (tab, index) {
          if (tab.props === undefined) {
            tab.props = {};
          }

          if (tab.selected && state.selectedTab !== index + 3) {
            state.selectedTab = index + 3;
          }

          if (constructor || !_this.props.tabs || !_this.props.tabs[index] || _this.props.tabs[index].id !== tab.id || tab.data !== _this.props.tabs[index].data) {
            if (tab.props.functions) {
              state.functions.mergeFunctionsObjects(tab.props.functions);
            }

            state[tab.id] = tab.data;
            state["".concat(tab.id, "Meta")] = tab.meta || _this.metaDescriptions[tab.id];

            if (state["".concat(tab.id, "Meta")]) {
              computeMetaFromData(state[tab.id], state["".concat(tab.id, "Meta")], props.sizes.zoom, state.functions);
              state["".concat(tab.id, "UpdatedRows")] = tab.updatedRows;
            }
          }
        });
      }

      return state;
    };

    _this.initMeta = function (meta_, callbacks, data, functions, zoom) {
      if (!meta_.table) {
        var meta = metaDescriptions("dataset", undefined, functions, callbacks).dataset;
        meta_.table = meta.table;
        meta_.row = meta.row;
        meta_.properties = meta.properties; // meta = meta_;
      }

      if (data && Array.isArray(data) && data.length && meta_.properties) {
        if (meta_.properties.length === 0) {
          computeMetaFromData(data, meta_, zoom, functions);
        }

        setPropertyAccessors(meta_.properties, data);
      }
    };

    _this.handleKeyEvent = function (e) {
      var tab = _this.tabs[_this.state.selectedTab].id;

      if (_this[tab] && _this[tab].handleKeyEvent) {
        return _this[tab].handleKeyEvent(e);
      }
    };

    _this.onChangeProperties = function (_ref) {
      var value = _ref.value,
          previousValue = _ref.previousValue,
          column = _ref.column,
          row = _ref.row;

      if (["select", "dataType"].includes(column.id) && value !== previousValue && [value, previousValue, row.dataType].includes("joined object")) {
        _this.changedProperties = true;
      }
    };

    _this.onRowDelete = function (_ref2) {
      var row = _ref2.row,
          status = _ref2.status;
      // console.log(row, status);
      row.deleted_ = status.deleted_;
      _this.changedProperties = true;
    };

    _this.onRowNew = function (message) {
      _this.changedProperties = true;
    };

    _this.onGetData = function (_ref3) {
      var data = _ref3.data,
          meta = _ref3.meta,
          status = _ref3.status;

      if (data && meta.table.object === "dataset" && _this.changedProperties) {
        var _this$state = _this.state,
            functions = _this$state.functions,
            sizes = _this$state.sizes;
        _this.changedProperties = false;

        _this.initMeta(meta, _this.state.callbacks, data, functions, sizes.zoom);
      }

      return true;
    };

    _this.applyFunctions = function (_ref4) {
      var updatedRows = _ref4.updatedRows;
      var functions = _this.state.functions;
      getUpdatedRows(updatedRows).filter(function (status) {
        return (status.row || {}).isLocal || (status.rowUpdated || {}).isLocal;
      }).forEach(function (status) {
        var row = status.rowUpdated || status.row;

        if (status.row) {
          functions.removeFunction(status.row.visibility, status.row.tp, status.row.id);
        }

        if (status.rowUpdated) {
          functions.setInitialFunction(status.rowUpdated.visibility, status.rowUpdated.tp, status.rowUpdated.id, status.rowUpdated.caption, status.rowUpdated.functionText);
        }
      });
      computeMeta(_this.state.meta, _this.zoomValue, _this.state.functions);
      return true;
    };

    _this.applyProperties = function (_ref5) {
      var data = _ref5.data;
      var meta = _this.state.meta;
      computeMeta(_objectSpread({}, meta, {
        properties: data
      }), _this.zoomValue, _this.state.functions);
      meta.properties = data.map(function (row) {
        return _objectSpread({}, row);
      }); // compute new or modified joined objects

      if (-1 !== meta.properties.findIndex(function (row) {
        var status = getRowStatus(_this.state.propertiesUpdatedRows, row);
        return row.dataType === "joined object" && row.accessor !== undefined && row.select !== undefined && (status.new_ || status.updated_ && (status.row.accessor !== status.rowUpdated.accessor || status.row.select !== status.rowUpdated.select || status.row.dataType !== "joined object"));
      })) {
        computeData(_this.state.data, meta);
        setPropertyAccessors(meta.properties, _this.state.data);
      } // compute new or modified analytics functions


      var properties = meta.properties.filter(function (row) {
        var status = getRowStatus(_this.state.propertiesUpdatedRows, row);
        return (row.aggregation || row.analytic) && typeof row.accessorFunction === "function" && !row.hidden && (status.new_ || status.updated_ && (status.row.accessor !== status.rowUpdated.accessor || status.row.analytic !== status.rowUpdated.analytic));
      });
      properties.forEach(function (property) {
        computeAnalytic(_this.state.data, property);
      });
      return true;
    };

    _this.initTabs = function (state, props) {
      var params = props.params,
          utils = props.utils,
          configurationMenus = props.configurationMenus,
          id = props.id,
          navigationKeyHandler = props.navigationKeyHandler,
          errorHandler = props.errorHandler;
      var selectedTab = state.selectedTab,
          data = state.data,
          meta = state.meta,
          filters = state.filters,
          updatedRows = state.updatedRows,
          functions = state.functions,
          status = state.status,
          functionUpdatedRows = state.functionUpdatedRows,
          functionsMeta = state.functionsMeta,
          functionsData = state.functionsData,
          propertiesMeta = state.propertiesMeta,
          propertiesUpdatedRows = state.propertiesUpdatedRows;
      var menu = configurationMenus || {};
      _this.tabs = [{
        id: "dataset",
        caption: "Dataset",
        index: 0,
        content: React.createElement(ZebulonTable, {
          key: 0,
          id: "".concat(id, "-dataset"),
          data: data,
          meta: meta,
          filters: filters,
          updatedRows: updatedRows,
          functions: functions,
          params: params,
          keyEvent: null,
          onTableEnter: _this.onTableEnter,
          ref: function ref(_ref6) {
            return _this.dataset = _ref6;
          },
          errorHandler: errorHandler,
          navigationKeyHandler: navigationKeyHandler,
          onGetData: _this.onGetData,
          resizable: false,
          utils: utils,
          contextualMenu: menu.dataset ? menu.dataset(_assertThisInitialized(_assertThisInitialized(_this))) : undefined
        })
      }, {
        id: "properties",
        caption: "Properties",
        index: 1,
        content: React.createElement(ZebulonTable, {
          key: 1,
          id: "".concat(id, "-properties"),
          data: _toConsumableArray(meta.properties),
          meta: propertiesMeta,
          updatedRows: propertiesUpdatedRows,
          onChange: _this.onChangeProperties,
          onRowDelete: _this.onRowDelete,
          onRowNew: _this.onRowNew,
          functions: functions,
          status: status,
          params: params,
          keyEvent: null,
          ref: function ref(_ref7) {
            return _this.properties = _ref7;
          },
          errorHandler: {},
          utils: utils,
          resizable: false,
          contextualMenu: menu.properties ? menu.properties(_assertThisInitialized(_assertThisInitialized(_this))) : undefined
        })
      }, {
        id: "functions",
        caption: "Functions",
        index: 2,
        content: React.createElement(ZebulonTable, {
          key: 2,
          id: "".concat(id, "-functions"),
          data: functionsData,
          meta: functionsMeta,
          updatedRows: functionUpdatedRows,
          functions: functions,
          params: params,
          keyEvent: null,
          ref: function ref(_ref8) {
            return _this.functions = _ref8;
          },
          errorHandler: {},
          utils: utils,
          resizable: false,
          contextualMenu: menu.functions ? menu.functions(_assertThisInitialized(_assertThisInitialized(_this))) : undefined
        })
      }];

      _this.initTabProps(state, props);

      return _this.tabs;
    };

    _this.initTabProps = function (state, props) {
      var selectedTab = state.selectedTab,
          sizes = state.sizes;
      var params = props.params,
          utils = props.utils,
          id = props.id,
          configurationMenus = props.configurationMenus;
      var menu = configurationMenus || {};

      if (props.tabs) {
        props.tabs.forEach(function (tab, index) {
          if (tab !== _this.tabs[3 + index]) {
            var Content = tab.content ? tab.content : ZebulonTable;
            _this.tabs[3 + index] = {
              id: tab.id,
              caption: tab.caption,
              props: tab.props,
              index: 3 + index,
              content: React.createElement(Content, {
                key: 3 + index,
                id: "".concat(id, "-").concat(tab.id),
                data: state[tab.id],
                meta: state["".concat(tab.id, "Meta")],
                updatedRows: state["".concat(tab.id, "UpdatedRows")],
                sizes: sizes,
                functions: state.functions,
                params: params,
                keyEvent: null,
                ref: function ref(_ref9) {
                  return _this[tab.id] = _ref9;
                },
                errorHandler: {},
                utils: utils,
                contextualMenu: menu[tab.id] ? menu[tab.id](_assertThisInitialized(_assertThisInitialized(_this))) : undefined
              })
            };
          }
        });
      }

      if (_this.tabs.length > 3 + (props.tabs || []).length) {
        _this.tabs.splice(3 + (props.tabs || []).length, _this.tabs.length - 3);
      }
    };

    _this.onSelectTab = function (index) {
      var selectedTab = _this.state.selectedTab;
      var canQuit = _this[_this.tabs[selectedTab].id].table ? _this[_this.tabs[selectedTab].id].table.canQuit : null;

      if (canQuit) {
        canQuit("quit", function (ok) {
          if (ok) {
            _this.setState({
              selectedTab: index
            });
          }
        });
      } else {
        _this.setState({
          selectedTab: index
        });
      }
    };

    var f = _props.functions;
    f.mergeFunctionsObjects([accessors, metaFunctions]);
    f.composeFunction("dataset", "actions", "exportMeta", f.getFunctionsObject());
    var _meta = _props.meta;

    _this.initMeta(_props.meta, _props.callbacks, _props.data, f, _props.sizes.zoom);

    computeMetaFromData(_props.data, _meta, _props.sizes.zoom, f);
    var _state = {
      selectedTab: _props.selectedTab || 0,
      data: _props.data,
      meta: _meta,
      updatedRows: _props.updatedRows || {},
      propertiesUpdatedRows: {},
      functionsUpdatedRows: {},
      functions: f,
      functionsData: f.getFunctionsArray((_meta.table || {}).object || "dataset", undefined, (_meta.table || {}).source),
      sizes: _props.sizes,
      filters: _props.filters,
      status: {},
      callbacks: _objectSpread({
        applyFunctions: _this.applyFunctions,
        applyProperties: _this.applyProperties
      }, _props.callbacks || {})
    };
    _this.zoomValue = _props.sizes.zoom || 1; // f = utils.mergeFunctions([accessors, metaFunctions], "properties");

    _this.metaDescriptions = metaDescriptions((_meta.table || {}).object || "dataset", (_meta.table || {}).source, _state.functions, _state.callbacks);
    _meta.table.actions = _this.metaDescriptions.dataset.table.actions;
    _state.propertiesMeta = _this.metaDescriptions.properties;
    computeMeta(_state.propertiesMeta, _props.sizes.zoom, _state.functions);
    _state.functionsProperties = f; // f = utils.mergeFunctions([accessors, metaFunctions], "functions");

    _state.functionsMeta = _this.metaDescriptions.functions;
    computeMeta(_state.functionsMeta, _props.sizes.zoom, _state.functions);
    _state.functionsFunctions = f;

    _this.initTabsState(_state, _props, true);

    _this.initTabs(_state, _props);

    _this.state = _state; // this.errorHandler = this.props.errorHandler || {};

    return _this;
  }

  _createClass(ZebulonTableAndConfiguration, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var state = {};

      if (nextProps.keyEvent !== this.props.keyEvent) {
        this.handleKeyEvent(nextProps.keyEvent);
      } else {
        if (nextProps.data !== this.props.data || nextProps.meta !== this.props.meta || nextProps.filters !== this.props.filters) {
          this.initMeta(nextProps.meta, this.state.callbacks, nextProps.data, this.state.functions, nextProps.sizes.zoom);
          state = {
            data: nextProps.data,
            meta: nextProps.meta,
            functions: this.state.functions,
            filters: nextProps.filters
          };
        }

        if (nextProps.updatedRows && nextProps.updatedRows !== this.props.updatedRows) {
          state.updatedRows = nextProps.updatedRows;
        }

        if (nextProps.sizes !== this.props.sizes) {
          state.sizes = nextProps.sizes;
        }

        if (nextProps.tabs) {
          state = this.initTabsState(state, nextProps);
        }

        this.setState(state);
        this.initTabProps(_objectSpread({}, this.state, state), nextProps);
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return nextProps.keyEvent === this.props.keyEvent;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      if (this.props.status.loading || this.props.status.loadingConfig) {
        return React.createElement("div", null, "Loading data...");
      } else if (this.props.status.error) {
        if (this.props.status.error.message === "No rows retrieved") {} else {
          return React.createElement("div", {
            style: {
              color: "red",
              width: "max-content"
            }
          }, React.createElement("p", null, this.props.status.error.type), React.createElement("p", null, this.props.status.error.message));
        }
      }

      var zoomValue = this.zoomValue;
      return React.createElement("div", null, React.createElement("div", {
        style: {
          display: "flex",
          height: 25 * zoomValue
        },
        className: "zebulon-tabs-list"
      }, this.tabs.map(function (tab, index) {
        return React.createElement("div", {
          key: index,
          style: {
            width: "".concat((100 / _this2.tabs.length).toFixed(2), "%")
          },
          className: cx({
            "zebulon-tabs-tab": true,
            "zebulon-tabs-tab-selected": index === _this2.state.selectedTab
          }),
          onClick: function onClick() {
            return _this2.onSelectTab(index);
          }
        }, tab.caption);
      })), React.createElement("div", {
        style: {
          height: this.props.sizes.height - 30 * zoomValue
        }
      }, this.tabs.map(function (tab) {
        return React.cloneElement(tab.content, _objectSpread({}, tab.props, {
          visible: tab.index === _this2.state.selectedTab,
          isActive: tab.index === _this2.state.selectedTab,
          sizes: _this2.state.sizes
        }));
      })));
    }
  }]);

  return ZebulonTableAndConfiguration;
}(Component);