import _toConsumableArray from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/toConsumableArray";
import _objectSpread from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/objectSpread";
import { utils } from "zebulon-controls"; // ----------------------------------
// common data access (row or fiels)
// ----------------------------------

export var cellData = function cellData(row, column, status, data, params, focused) {
  var editable = // focused &&
  !(status || {}).deleted_ && row.editable_ && (column.editableFunction ? column.editableFunction({
    column: column,
    row: row,
    status: status || {},
    data: data,
    params: params
  }) : column.editable); //  dont use accessor for analytics computed data

  var select = column.select && editable && focused ? column.selectItems || column.select : undefined,
      dataType = typeof column.dataType === "function" ? column.dataType({
    row: row
  }) : column.dataType;
  var value = column.analytic ? row[column.id] : column.accessorFunction ? column.accessorFunction({
    column: column,
    row: row,
    params: params,
    status: status,
    data: data
  }) : row[column.id];

  if (["date", "month", "year"].includes(dataType) && typeof value === "string") {
    value = new Date(value);
  } //  map the data


  if (select) {
    if (column.selectFunction && editable && focused && !column.selectItems) {
      select = column.selectFunction({
        column: column,
        row: row,
        data: data,
        focused: focused
      });
    }

    if (!utils.isPromise(select) && !Array.isArray(select) && utils.isObject(select) && !column.accessorFunction) {
      select = Object.values(select);
    }

    if (column.primaryKeyAccessorFunction) {
      value = {
        value: column.primaryKeyAccessorFunction({
          column: column,
          row: row,
          params: params,
          status: status,
          data: data
        }),
        caption: value
      };
    }
  }

  return {
    editable: editable,
    select: select,
    value: value === undefined ? null : value,
    dataType: dataType
  };
};
export var computeRows = function computeRows(data, meta) {
  var startIndex = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  var noDataMutation = arguments.length > 3 ? arguments[3] : undefined;
  var foreignObjects = [];
  foreignObjects = meta.properties.filter(function (column) {
    return column.accessor !== undefined && (column.dataType === "joined object" && column.select !== undefined || column.dataType === "object" && column.hidden);
  });
  var _meta$table = meta.table,
      pk = _meta$table.pk,
      lk = _meta$table.lk,
      rwd = _meta$table.rwd;
  data.forEach(function (row, index) {
    // if (calcIndex) {
    row.index_ = index + (startIndex || 0); // }

    if (pk) {
      meta.indexPk[row[pk.id]] = row.index_;
    }

    if (lk) {
      meta.indexLk[row[lk.id]] = row.index_;
    }

    if (rwd) {
      meta.indexRowId[row[rwd.id]] = row.index_;
    }

    foreignObjects.forEach(function (column) {
      return row[column.id] = column.accessorFunction({
        row: row
      });
    });

    if (noDataMutation) {
      data[index] = _objectSpread({}, row);
    }
  });
};
export var computeAnalytics = function computeAnalytics(data, meta) {
  var columns = meta.properties.filter(function (column) {
    return (column.aggregation || column.analytic) && typeof column.accessorFunction === "function" && !column.hidden;
  });
  columns.forEach(function (column) {
    computeAnalytic(data, column);
  });
};
export var computeData = function computeData(data, meta, startIndex, noDataMutation) {
  computeRows(data, meta, startIndex, noDataMutation);
  computeAnalytics(data, meta);
}; // ----------------------------
//  aggregations
//  ---------------------------
// export const aggregations = {
//   count: values => values.length,
//   sum: values => values.reduce((sum, value) => (sum += value), null),
//   min: values =>
//     values.reduce(
//       (min, value) => (min = min === null || value < min ? value : min),
//       null
//     ),
//   max: values =>
//     values.reduce(
//       (max, value) => (max = max === null || value > max ? value : max),
//       null
//     ),
//   avg: values =>
//     values.length === 0 ? null : aggregations.sum(values) / values.length,
//   weighted_avg: values => {
//     const wavg = values.reduce(
//       (wavg, value) => {
//         wavg.v0 += value.v0;
//         wavg.v1 += value.v1;
//         return wavg;
//       },
//       { v0: null, v1: null }
//     );
//     return wavg.v0 === 0 && wavg.v1 === 0 ? null : wavg.v0 / wavg.v1;
//   },
//   delta: values => {
//     const delta = values.reduce(
//       (delta, value) => {
//         delta.v0 += value.v0;
//         delta.v1 += value.v1;
//         return delta;
//       },
//       { v0: null, v1: null }
//     );
//     return delta.v0 - delta.v1;
//   },
//   prod: values => values.reduce((prod, value) => (prod *= value), null)
// };
// -------------------------------------
// compute new description
// -------------------------------------

var sortFunction = function sortFunction(accessor) {
  return function (rowA, rowB) {
    var a = accessor(rowA),
        b = accessor(rowB);
    var x = 0,
        i = 0;

    while (!x && i < a.length) {
      x = (a[i] > b[i]) - (b[i] > a[i]);
      i++;
    }

    return x;
  };
};

export var computeAnalytic = function computeAnalytic(data, column) {
  var d = data.concat([]);
  var groups = [[]]; // sort;

  var accessor = function accessor(row) {
    var acc = [];

    if (column.groupByAccessorFunction) {
      acc = acc.concat(column.groupByAccessorFunction({
        row: row
      }));
    }

    if (column.sortAccessorFunction) {
      acc = acc.concat(column.sortAccessorFunction({
        row: row
      }));
    }

    return acc;
  };

  if (column.sortAccessorFunction || column.groupByAccessorFunction) {
    d.sort(sortFunction(accessor));
  } // group by and window interval


  var values = [];
  d.forEach(function (row, index) {
    // row._index = groups[groups.length - 1].length;
    row._window = {
      value: (column.accessorFunction || function (_ref) {
        var row = _ref.row;
        return row[column.accessor];
      })({
        row: row
      }),
      groupBy: column.groupByAccessorFunction ? JSON.stringify(column.groupByAccessorFunction({
        row: row
      })) : null
    };

    if (column.comparisonAccessorFunction) {
      row._window.ref = column.comparisonAccessorFunction({
        row: row
      });

      if (column.startFunction) {
        row._window.start = column.startFunction(row._window.ref);
      }

      if (column.endFunction) {
        row._window.end = column.endFunction(row._window.ref);
      }
    }

    if (index > 0 && row._window.groupBy !== d[index - 1]._window.groupBy) {
      if (!column.comparisonAccessorFunction) {
        var value = column.aggregationFunction(values);
        groups[groups.length - 1].forEach(function (row) {
          return row[column.id] = value;
        });
        values = [];
      }

      groups.push([]);
    }

    if (!column.comparisonAccessorFunction) {
      values.push(row._window.value);
    }

    groups[groups.length - 1].push(row);
  }); // computation

  if (column.comparisonAccessorFunction) {
    groups.forEach(function (group) {
      return group.forEach(function (row, index) {
        var i = index - 1,
            values = [row._window.value];

        while (i >= 0 && (row._window.start === undefined || group[i]._window.ref >= row._window.start)) {
          values.push(group[i]._window.value);
          i--;
        }

        i = index + 1;

        while (i < group.length && (row._window.end === undefined || group[i]._window.ref <= row._window.end)) {
          values.push(group[i]._window.value);
          i++;
        }

        row[column.id] = column.aggregationFunction(values);
      });
    });
  } else {
    var value = column.aggregationFunction(values);
    groups[groups.length - 1].forEach(function (row) {
      return row[column.id] = value;
    });
  }

  return data;
};
export var groupBy = function groupBy(data, groupByFunction) {
  var d = data.concat([]);
  var groups = [[]];
  var map = {};
  d.forEach(function (row, index) {
    var groupBy = groupByFunction({
      row: row
    });

    if (!map[groupBy]) {
      map[groupBy] = [];
    }

    map[groupBy].push(row);
  });
  return groups;
}; // export const computeAudit = (rowUpdated, row, meta, audits) => {
//   const rows = [];
//   if (rowUpdated) {
//     rows.push(rowUpdated);
//   }
//   if (audits && audits.length) {
//     const audits_ = [...audits].reverse();
//     let nextRow = row;
//     audits_.forEach(audit => {
//       const { user_, timestamp_, status_ } = audit;
//       rows.push({
//         ...nextRow,
//         user_,
//         time_: new Date(timestamp_),
//         status_
//       });
//       nextRow = { ...nextRow, ...audit.row };
//     });
//     const foreignObjects = meta.properties.filter(
//       column => column.dataType === "joined object"
//     );
//     if (foreignObjects.length) {
//       rows.forEach(row => {
//         foreignObjects.forEach(
//           column => (row[column.id] = column.accessorFunction({ row }))
//         );
//       });
//     }
//   } else if (!rowUpdated) {
//     rows.push(row);
//   }
//   return rows;
// };

export var computeAudit = function computeAudit(rowUpdated, audits) {
  var rows = [];

  if (rowUpdated) {
    rows.push(rowUpdated);
  }

  if (audits && audits.length) {
    var audits_ = audits.map(function (audit) {
      return _objectSpread({}, audit, {
        time_: new Date(audit.timestamp_)
      });
    });
    audits_.reverse();
    rows.push.apply(rows, _toConsumableArray(audits_));
  }

  return rows;
};
export var getRegExp = function getRegExp(v) {
  return new RegExp(v.replace(" ", "[".concat(String.fromCharCode(32, 160), "]")), "i");
};

var stringValue = function stringValue(property, row) {
  var accessor = property.accessorFunction || function (_ref2) {
    var row = _ref2.row;
    return row[property.id];
  };

  var v = accessor({
    row: row
  });

  if (!utils.isNullOrUndefined(v)) {
    if (property.dataType === "string") {
      return v.toUpperCase();
    } else if (property.dataType === "number") {
      return utils.numberToString(v);
    } else if (property.dataType === "date") {
      return utils.dateToString(v);
    } else {
      return null;
    }
  }
};

export var computeRowSearch = function computeRowSearch(data, properties, dataStrings) {
  var strings = [];
  data.forEach(function (row, index) {
    if (!dataStrings[row.index_]) {
      var rowStrings = [];
      properties.forEach(function (property) {
        var v = stringValue(property, row);

        if (!utils.isNullOrUndefined(v)) {
          rowStrings.push(v);
        }
      });
      dataStrings[row.index_] = rowStrings.join("~~");
    }

    strings.push(dataStrings[row.index_]);
  });
  return strings;
};
export var rowSearch = function rowSearch(dataStrings, exp) {
  var indexes = [];
  dataStrings.forEach(function (rowString, index) {
    if (exp.test(rowString)) {
      indexes.push(index);
    }
  });
  return indexes;
};
export var cellSearch = function cellSearch(row, properties, exp) {
  var propertyStart = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
  var direction = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 1;
  var i = propertyStart;

  while (properties.length > i && i >= 0 && !exp.test(stringValue(properties[i], row) || "")) {
    i += direction;
  }

  return properties.length > i && i >= 0 ? i : null;
};