import _defineProperty from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/defineProperty";
import { utils } from "zebulon-controls";
import { cellData } from "./compute.data";
export var getSelection = function getSelection() {
  var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "xls";
  var selectedRange = arguments.length > 1 ? arguments[1] : undefined;
  var columns = arguments.length > 2 ? arguments[2] : undefined;
  var filteredData = arguments.length > 3 ? arguments[3] : undefined;
  var updatedRows = arguments.length > 4 ? arguments[4] : undefined;
  var data = arguments.length > 5 ? arguments[5] : undefined;
  var params = arguments.length > 6 ? arguments[6] : undefined;
  var columnSeparator = type === "csv" ? "," : "\t";
  var rowStart = Math.min(selectedRange.start.rows, selectedRange.end.rows);
  var rowEnd = Math.max(selectedRange.start.rows, selectedRange.end.rows);
  var columnStart = Math.min(selectedRange.start.columns, selectedRange.end.columns);
  var columnEnd = Math.max(selectedRange.start.columns, selectedRange.end.columns);
  var outputs = [];
  var output = "";

  for (var iColumn = columnStart; iColumn <= columnEnd; iColumn++) {
    if (!columns[iColumn].hidden) {
      output += columnSeparator + JSON.stringify(columns[iColumn].caption);
    }
  }

  outputs.push(output.slice(1));

  for (var iRow = rowStart; iRow <= rowEnd; iRow++) {
    var row = filteredData[iRow];
    output = "";

    for (var _iColumn = columnStart; _iColumn <= columnEnd; _iColumn++) {
      var column = columns[_iColumn];

      if (!column.hidden) {
        var value = cellData(row, column, updatedRows[row.index_], data, params, true).value;

        if (utils.isNullOrUndefined(value)) {
          value = "";
        } else if (column.dataType === "date" && value !== null) {
          value = utils.dateToString(value, undefined || "dd/mm/yyyy");
        } else if (utils.isObject(value)) {
          value = value.caption;
        }

        output += columnSeparator + JSON.stringify(value);
      }
    }

    outputs.push(output.slice(1));
  }

  return outputs.join("\n");
};
export var buildPasteArray = function buildPasteArray() {
  var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "xls";
  var clipboard = arguments.length > 1 ? arguments[1] : undefined;
  var this_ = arguments.length > 2 ? arguments[2] : undefined;
  var selectCell = arguments.length > 3 ? arguments[3] : undefined;
  var columns = this_.state.meta.properties,
      selectedCell = this_.state.selectedRange.end,
      onChange = this_.onChange,
      canQuit = this_.canQuit,
      filteredData = this_.state.filteredData,
      updatedRows = this_.state.updatedRows,
      data = this_.state.data,
      params = this_.props.params;
  var columnSeparator = type === "csv" ? "," : "\t"; // a voir detection du separateur

  var lines = clipboard.replace(/\r/g, "").split("\n");
  lines.pop();
  var cells = lines.map(function (line) {
    return line.split(columnSeparator);
  });
  var cellsValue = [];
  cells.forEach(function (rowCells, rowIndex) {
    var row = filteredData[selectedCell.rows + rowIndex];
    var columnIndex = 0;
    rowCells.forEach(function (value) {
      var col = selectedCell.columns + columnIndex < columns.length;
      var column = columns[selectedCell.columns + columnIndex];

      while (col && column.hidden && column.index_ + 1 < columns.length) {
        columnIndex++;
        col = selectedCell.columns + columnIndex < columns.length;
        column = columns[selectedCell.columns + columnIndex];
      }

      var cell = {
        rows: selectedCell.rows + rowIndex,
        columns: column.index_
      };
      var editable = col && column.editableFunction ? column.editableFunction({
        column: column,
        row: row,
        status: updatedRows[row.index_] || {},
        data: data,
        params: params
      }) : column.editable;

      if (editable) {
        var v = value;
        var _column = column,
            dataType = _column.dataType,
            format = _column.format;

        if (dataType === "boolean") {
          v = v === "true";
        } else if (dataType === "date") {
          v = utils.stringToDate(v, format);
        } else if (dataType === "number") {
          v = v === "" ? null : Number(value);
        }

        cell.value = v;
        cell.columnId = column.id;
        cellsValue.push(cell);
      }

      columnIndex++;
    });
  }); //  mangement of callback and users interractions

  cellsValue.reverse();

  var cellValue = function cellValue(ok_, previousRow) {
    if (!ok_ || cellsValue.length === 0) {
      this_.isPasting = false;
      this_.forceUpdate();
      return;
    }

    var ok = ok_;
    var cell = cellsValue.pop();
    this_.isPasting = true;

    var cellV = function cellV(ok_) {
      var endCell = function endCell(ok_) {
        if (ok_) {
          cellValue(ok_, cell.rows);
        }
      };

      if (!ok_) {
        return false;
      }

      selectCell(cell);
      var row = filteredData[cell.rows];
      var column = columns[cell.columns]; // can change value

      if (!onChange({
        value: {
          value: cell.value
        },
        row: row,
        column: column
      })) {
        return false;
      }

      row[cell.columnId] = cell.value; // object in select input

      if (column.reference && column.selectItems) {
        var item = Object.values(column.selectItems).find(function (item) {
          return column.accessorFunction({
            row: _defineProperty({}, column.reference, item)
          }) === cell.value;
        });
        row[column.reference] = item;

        if (column.setForeignKeyAccessorFunction) {
          column.setForeignKeyAccessorFunction({
            value: item.pk_,
            row: row
          }); // column.setForeignKeyAccessorFunction({
          //   value: column.primaryKeyAccessorFunction({
          //     row: { [column.reference]: item }
          //   }),
          //   row
          // });
        }
      } // can quit cell


      var ok = canQuit("cellQuit", endCell);

      if (ok !== undefined) {
        endCell(ok);
      }
    }; // can quit row


    if (previousRow !== undefined && previousRow !== cell.rows) {
      ok = canQuit("rowQuit", cellV);
    }

    if (ok !== undefined) {
      cellV(ok);
    }
  };

  cellValue(true, undefined);
  this_.isPasting = false;
  return cells;
};